;  Programm: "dingew.lsp" zeichnet Durchgansgewinde in der gewnschten
;            Lage in Vorderansicht und Draufsicht sichtbar oder verdeckt.
;
;  Erforderliche Zusatzdatei: dingew.ldt
;                             dingew.dcl
;                             dingew.slb
;
;  Programmautor: Karl Maurer   (C) 1998
;
;  Anmerkung: Vom Programm werden die Layer "SL_TBF", "SLM_TBF" "SLV_TBF" 
;             und "SLD" erzeugt und die einzelnen Zeichnungselemente auf 
;             diese Layer gezeichnet.
;
;             Gewindelinien auf "SLD_TBF"
;             Mittellinien auf "SLM_TBF"
;             Verdeckte Linien "SLV_TBF"
;             Alle anderen Linien auf "SL_TBF".
;
;  Alle vorher eingestellten Systemvariablen die durch dieses Programm
;  verndert wurden, werden automatisch wieder zurckgesetzt.
;
;********************* Programmbeginn ******************

(prompt "\n Bitte warten..... Ingew.lsp geladen.")

(Defun C:DINGW (/ A B C D E F dk dm a1 aw bw cw lg efp p1 p2 p3 p4 p5 p6 p7 
                 p8 p9 p10 p11 p12 p13 p14 p15 p16 wi_li wi_re ncd ML AKR 
                 DGS DGV DS DV dcl dcl_dingew slb ncd DM_ingew)


(setq cm (getvar "cmdecho"))
(setq bl (getvar "blipmode"))
(setq os (getvar "osmode"))
(setq alay (getvar "clayer"))

(setvar "cmdecho" 0)
(setvar "blipmode" 0)
(setvar "osmode" 0)
(tb_layer)
(princ)
)

(defun altsv ()
(setvar "blipmode" bl)
(setvar "osmode" os)
(setvar "cmdecho" cm)
)

(defun *error* (emsg)
(princ emsg)
(altsv)
(princ)
)

;************************** Layer erzeugen *************************

(defun tb_layer ()

(command "Layer" "M" "SL_TBF" "FA" "7" "" "LT" "" "SL_TBF" ""
         "Layer" "M" "SLM_TBF" "FA" "2" "" "LT" "Mitte" "SLM_TBF" ""
         "Layer" "M" "SLD_TBF" "FA" "2" "" "LT" "" "SLD_TBF" ""
         "Layer" "M" "SLV_TBF" "FA" "1" "" "LT" "Verdeckt" "SLV_TBF" "")

(command "layer" "SE" alay "")

  (Start_ingew)

);end defun

;************************Zusatzdatei ffnen***********************

(defun Start_ingew ()

(setq ncd (findfile "dingew.ldt"))
    
    (If (= Nil ncd)
      (progn
      (princ "Datei dingew.ldt kann nicht geffnet werden!")
       (setq vz (getstring t "\n Verzeichnis der Zusatzdatei eingeben: "))
        (setq A (Open (strcat "/" vz "/" "dingew.ldt") "r"))
     );end progn
   );end if

     (if ncd (setq A (Open ncd "r")) )
 
 (ingew_dcl)

);end defun

;************************ DCL-Datei starten ************************

(defun ingew_dcl ()

(setq dcl (findfile "dingew.dcl"))
 (setq slb (findfile "dingew.slb"))
  (setq dcl_dingew (load_dialog "dingew.dcl")) 
   (if (not (new_dialog "dingew" dcl_dingew)) (exit))
    (setq hilf (findfile "dingew.hil"))

(setq DM_ingew (list " M3" " M4" " M5" " M6" " M8" " M10" " M12" " (M14)" 
                     " M16" " (M18)" " M20" " (M22)" " M24" " (M27)" " M30" 
                     " (M33)" " M36" " (M39)" " M42" " (M45)" " M48" " (M52)" 
                     " M56" " (M60)" " M64"))

(setq Bre (dimx_tile "DGW_S"))
(setq Hoe (dimy_tile "DGW_S"))
(start_image "DGW_S")
(slide_image 0 0 bre hoe "dingew(d_gew_vs)")
(end_image)

(setq Bre (dimx_tile "DGW_V"))
(setq Hoe (dimy_tile "DGW_V" ))
(start_image "DGW_V")
(slide_image 0 0 bre hoe "dingew(d_gew_VV)")
(end_image)

(setq Bre (dimx_tile "DS_S"))
(setq Hoe (dimy_tile "DS_S"))
(start_image "DS_S")
(slide_image 0 0 bre hoe "dingew(i_gew_ds)")
(end_image)

(setq Bre (dimx_tile "DS_V"))
(setq Hoe (dimy_tile "DS_V"))
(start_image "DS_V")
(slide_image 0 0 bre hoe "dingew(i_gew_dv)")
(end_image)

(action_tile "DGW_S" "(setq DGS (atoi $value) GGV 0 GGS 0 DGV 0 DS 0 DV 0) 
                      (mod_ingew) (dm_list) ")
(action_tile "DGW_V" "(setq DGV (atoi $value) GGV 0 GGS 0 DGS 0 DS 0 DV 0) 
                      (mod_ingew)(dm_list) ")
(action_tile "DS_S" "(setq DS (atoi $value) GGV 0 GGS 0 DGV 0 DGS 0 DV 0) 
                     (mod_ingew) (dm_list) ")
(action_tile "DS_V" "(setq DV (atoi $value) GGV 0 GGS 0 DGV 0 DGS 0 DS 0) 
                     (mod_ingew) (dm_list) ")
(action_tile "DM" "(setq DM (atoi $value)) (DM_ingw) ")
(action_tile "ML" "(setq ML (atoi $value))")
(action_tile "AKR" "(setq AKR (atoi $value))")
(action_tile "hilfe" "(setq hilfe (atoi $value)) (hil)")
(action_tile "accept" "(if (/= DM nil) (done_dialog 1))")

(setq OK (start_dialog))

     (if (= OK 1) (dat_ingew))

(action_tile "cancel" "(done_dialog)")
  (unload_dialog dcl_dingew)

(princ)
);end defun

;************************ Hilfedatei anzeigen ****************

(defun hil ()

(if (= hilfe 1)
    (startapp "notepad" hilf))

);end defun

;******************** Durchmesser anzeigen *****************

(defun dm_list ()

      (start_list "DM") (mapcar 'add_list DM_ingew) (end_list)

);end defun

;******************* Einstellungen ndern ************************

(defun mod_ingew ()

   (cond
      ((= DGS 1) (mode_tile "ML" 0) (mode_tile "AKR" 1))
      ((= DGV 1) (mode_tile "ML" 0) (mode_tile "AKR" 1))
      ((= DS 1)  (mode_tile "ML" 1) (mode_tile "AKR" 0))
      ((= DV 1)  (mode_tile "ML" 1) (mode_tile "AKR" 0))
   );end cond
 
);end defun

;********************** Durchmesser bestimmen ********************

(defun DM_ingw ()

  (cond
     ((= dm 0) (setq dm 3)) ((= dm 1) (setq dm 4)) ((= dm 2) (setq dm 5))
     ((= dm 3) (setq dm 6)) ((= dm 4) (setq dm 8)) ((= dm 5) (setq dm 10))
     ((= dm 6) (setq dm 12)) ((= dm 7) (setq dm 14)) ((= dm 8) (setq dm 16)) 
     ((= dm 9) (setq dm 18)) ((= dm 10) (setq dm 20)) ((= dm 11) (setq dm 22)) 
     ((= dm 12) (setq dm 24)) ((= dm 13) (setq dm 27)) ((= dm 14) (setq dm 30))
     ((= dm 15) (setq dm 33)) ((= dm 16) (setq dm 36)) ((= dm 17) (setq dm 39)) 
     ((= dm 18) (setq dm 42)) ((= dm 19) (setq dm 45)) ((= dm 20) (setq dm 48)) 
     ((= dm 21) (setq dm 52)) ((= dm 22) (setq dm 56)) ((= dm 23) (setq dm 60)) 
     ((= dm 24) (setq dm 64))  
   );end cond

);ende defun

;************************ Daten einlesen ************************

(defun dat_ingew ()

(setq a1 (itoa dm)
      B (strcat "M" a1)
      C (Read-line A))
   
    (If (= C nil) (setq C ""))
     (setq D C)
   
   (While (/= D "")
    
    (If (And (= (Substr D 1 (Strlen B)) B) (= "," (Substr D (1+ (Strlen B)) 1)) )
      (progn 
       (setq D "")

        (Les-ingew 1) (Les-ingew 2) (Les-ingew 3)

   (cond
      ((or (= GGS 1) (= GGV 1) (= DGS 1) (= DGV 1)) (KW_ingew))
      ((or (= DS 1) (= DV 1)) (DS_ingew))
    );end cond
   );end progn
    
    (progn

     (setq C (Read-line A))
    
    (If (= C nil) (setq C ""))
     (setq D C)
    
   );end progn
  );end if
 );end while

);end defun

;*********************** Daten umwandeln **********************

(Defun Les-ingew (NR)

  (setq D "T")

  (cond 
     ((= NR 2) (setq E "")) ((= NR 3) (setq F "")))
   
   (While (/= D "")
    (setq D (Substr C 1 1))
   
    (If (Or (= D ",") (= D ""))
     (progn
      (setq D "")
    
    (if (/= C "")
     (setq C (Substr C 2 (- (Strlen C) 1)))
   );end if

  (cond 
     ((= NR 2) (setq E (Atof E))) ((= NR 3) (setq F (Atof F)))
   );end cond
 );end if
   
   (progn

  (cond 
     ((= NR 2) (setq E (Strcat E D))) ((= NR 3) (setq F (Strcat F D)))
  );end cond

    (setq C (Substr C 2 (- (Strlen C) 1)))

   );end progn
  );end if
 );end while

);end defun

;************* Konstruktionspunkte Vorderansicht **************

(Defun KW_ingew ()
  
(setq dk (- E F) )
   
   (if (<= (- E dk) 0.6)
     (setq dk (- E 0.6))
  );end if

(setq efp (getpoint "\n Einfgepunkt:"))
(setq lg (getpoint efp "\n Gewindelnge (zeigen oder eingeben):"))
(setq lg (distance efp lg))
(setq wi (getorient efp "\n Einfgerichtung zeigen oder Winkel eingeben"))

(setq p1 (polar efp (- wi (/ pi 2.0)) (/ dk 2))   
      p2 (polar efp (- wi (/ pi 2.0)) (/ E 2.0))
      p3 (polar efp (+ wi (/ pi 2.0)) (/ dk 2))   
      p4 (polar efp (+ wi (/ pi 2.0)) (/ E 2.0))
      p5 (polar p1 wi lg)   
      p6 (polar p2 wi lg)
      p7 (polar p3 wi lg)
      p8 (polar p4 wi lg)
      p9 (polar efp (+ wi pi) 2)
      p10 (polar efp wi (+ lg 2)) )

  (cond
     ((= DGS 1) (ZE_dgs))
     ((= DGV 1) (ZE_dgv))
  );end cond

);end defun

;*********** Durchgangsgewinde sichtbar zeichnen *************

(defun ZE_dgs ()

(command "Layer" "SE" "SL_TBF" ""
         "Linie" p1 p5 "" "Linie" p3 p7 ""
         "Layer" "SE" "SLD_TBF" ""
         "Linie" p2 p6 "" "Linie" p4 p8 "")
       
   (if (= ML 1)
      (command "Layer" "M" "SLM_TBF" ""
               "Linie" p9 p10 "")
  );end if

 (command "Layer" "SE" alay "")

 (close A)
(altsv)

);end defun

;************* Durchgangsgewinde verdeckt zeichnen *************

(defun ZE_dgv ()

(command "Layer" "SE" "SLV_TBF" ""
         "Linie" p2 p6 "" "Linie" p4 p8 "" "Linie" p1 p5 "" "Linie" p3 p7 "")
       
   (if (= ML 1)
      (command "Layer" "M" "SLM_TBF" ""
               "Linie" p9 p10 "")
  );end if

 (command "Layer" "SE" alay "")

 (close A)
(altsv)

);end defun

;**************** Konstruktionspunkte Draufsicht *************

(defun DS_ingew ()

(setq aw (* pi 1.5)  
      bw (* pi 2)  
      cw (/ pi 2)
      dk (- E F)
      wi_li (* pi (/ 190.0 180))
      wi_re (* pi (/ 260.0 180)) )
   
   (if (<= (- E dk) 0.6)
     (setq dk (- E 0.6))
  );end if

(setq efp (getpoint "\n Einfgepunkt"))
(setq p11 (polar efp wi_li (/ E 2.0))
      p12 (polar efp wi_re (/ E 2.0)) 
      p13 (polar efp pi (+ (/ E 2.0) 2))
      p14 (polar efp bw (+ (/ E 2.0) 2))
      p15 (polar efp cw (+ (/ E 2.0) 2))
      p16 (polar efp aw (+ (/ E 2.0) 2)) )

   (cond
      ((= DS 1) (ZE_ds))
      ((= DV 1) (ZE_dv))
   );end cond

);end defun

;**************** Draufsicht sichtbar zeichnen *****************

(defun ZE_ds ()

(command "Layer" "SE" "SL_TBF" ""
         "Kreis" efp "D" dk 
         "Layer" "SE" "SLD_TBF" ""
         "Bogen" p12 "z" efp p11) 
    
   (if (= AKR 1)
      (command "Layer" "SE" "SLM_TBF" ""
               "Linie" p13 p14 "" "Linie" p15 p16 "")
   );end if

(command "Layer" "SE" alay "")

 (close A)
(altsv)

);end defun

;**************** Draufsicht verdeckt zeichnen *****************

(defun ZE_dv ()

(command "Layer" "SE" "SLV_TBF" ""
         "Kreis" efp "D" dk "Bogen" p12 "z" efp p11) 
    
   (if (= AKR 1)
      (command "Layer" "SE" "SLM_TBF" ""
               "Linie" p13 p14 "" "Linie" p15 p16 "")
   );end if

(command "Layer" "SE" alay "")

 (close A)
(altsv)

);end defun

;************************* Programmende *************************

(prompt "\n dingew.lsp geladen. Mit Eingabe DINGW und RETURN starten")
(princ)


