;  Programm: "DIN_6331.lsp" zeichnet Sechskantmuttern mit Bund 1,5 d hoch 
;            hnlich DIN-6331 in Vorderansicht, Seitenansicht und Draufsicht.
;
;  Erforderliche Zusatzdatei: DIN_6331.ldt
;                             DIN_6331.dcl
;                             din_6331.slb
;
;  Programmiert von: Karl Maurer   (C)  1998
;
;  Einsatzbereich: AutoCAD 12,13,14 DOS/Windows/NT
;
;  Anmerkung: Vom Programm werden die Layer "SL_TB", "SLM_TB" und "SLD_TB" automatisch 
;             gesetzt und die einzelnen Zeichnungselemente auf diese Layer 
;             gezeichnet.
;
;             Gewindelinien auf "SLD_TB"
;             Mittellinien auf "SLM_TB"
;             Alle anderen Linien auf "SL_TB".
;
;  Alle vorher eingestellten Systemvariablen die durch dieses Programm
;  verndert wurden, werden bei Abbruch oder Verlassen des Programmes
;  automatisch wieder zurckgesetzt.
;
;*********************** Programmbeginn **********************

(prompt "\n Bitte warten...Programm wird geladen!")

(Defun C:MU6331 (/ A B C D E F G H I J ML ncd vz a1 dm aw bw cw dk efp em Ra 
                  Ls hbog lpa p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 p11 p12 p13 p14 
                  p15 p16 p17 p18 p19 p20 p21 p22 p23 p24 p25 p26 p27 efp p1s 
                  p2s p3s p4s p5s p6s p7s p8s p9s p10s p11s p12s p13s p14s 
                  p15s p16s p17s p18s p19s p20s p21s p22s p23s p24s p25s p26s 
                  p27s re rk rb di lk lb akr p1d p2d p3d p4d p5d p6d p7d p8d 
                  p9d p10d p11d p12d p13d dcl_6331 dcl slb Bre Hoe VS VSG SA 
                  SAG DS DSG count counts ele_tbkm blockef)

(setq cm (getvar "cmdecho"))
(setq bl (getvar "blipmode"))
(setq os (getvar "osmode"))
(setq alay (getvar "clayer"))
(setq lmc (getvar "Limcheck"))

(setvar "cmdecho" 0)
(setvar "blipmode" 0)
(setvar "osmode" 0)
(setvar "Limcheck" 0)
(tb_layer)
)

(defun altsv ()
(setvar "blipmode" bl)
(setvar "osmode" os)
(setvar "cmdecho" cm)
(setvar "Limcheck" lmc)
)
                  
(defun *error* (emsg)
(close A)
(princ emsg)
(altsv)
(princ)
)

;************************** Layer erzeugen *************************

(defun tb_layer ()

(command "Layer" "M" "SL_TB" "FA" "7" "" "LT" "" "SL_TB" ""
         "Layer" "M" "SLM_TB" "FA" "2" "" "LT" "Mitte" "SLM_TB" ""
         "Layer" "M" "SLD_TB" "FA" "2" "" "LT" "" "SLD_TB" "")

(command "layer" "SE" alay "")

(Start_6331)

);end defun

;********************** Zusatzdatei ffnen ***********************

(defun Start_6331 ()
(setq ncd (findfile "din_6331.ldt"))

    (If (= Nil ncd)
      (progn

       (princ "Datei din_6331.ldt kann nicht geffnet werden!")
        (setq vz (getstring t "\n Verzeichnis der Zusatzdatei eingeben: "))
         (setq A (Open (strcat "/" vz "/" "din_6331.ldt") "r"))
     );end progn
   );edn if

    (if ncd (setq A (Open ncd "r")))

 (M6331_dcl)

);end defun

;************************ Dialogbox ffnen ***********************

(defun M6331_dcl ()

(setq dcl (findfile "DIN_6331.dcl"))
 (setq slb (findfile "din_6331.slb"))
  (setq dcl_6331 (load_dialog "DIN_6331.dcl")) 
   (if (not (new_dialog "DIN_6331" dcl_6331 )) (exit) ) 
    (setq hilf (findfile "din_6331.hil"))

(setq DM_6331 (list " M6" " M8" " M10" " M12" " M16" " M20" " M24" " M27" " M30" 
               " M36" " M42" " M48")) 

(setq Bre (dimx_tile "S6331V"))
(setq Hoe (dimy_tile "S6331V"))
(start_image "S6331V")
(slide_image 0 0 bre hoe "DIN_6331(VA_6331)")
(end_image)

(setq Bre (dimx_tile "S6331S"))
(setq Hoe (dimy_tile "S6331S"))
(start_image "S6331S")
(slide_image 0 0 bre hoe "DIN_6331(SA_6331)")
(end_image)

(setq Bre (dimx_tile "S6331VG"))
(setq Hoe (dimy_tile "S6331VG"))
(start_image "S6331VG")
(slide_image 0 0 bre hoe "DIN_6331(6331VMSE)")
(end_image)

(setq Bre (dimx_tile "S6331SG"))
(setq Hoe (dimy_tile "S6331SG"))
(start_image "S6331SG")
(slide_image 0 0 bre hoe "DIN_6331(6331SMSE)")
(end_image)

(setq Bre (dimx_tile "S6331D"))
(setq Hoe (dimy_tile "S6331D"))
(start_image "S6331D")
(slide_image 0 0 bre hoe "DIN_6331(DS1_6331)")
(end_image)

(setq Bre (dimx_tile "S6331DG"))
(setq Hoe (dimy_tile "S6331DG"))
(start_image "S6331DG")
(slide_image 0 0 bre hoe "DIN_6331(DS2_6331)")
(end_image)

(action_tile "S6331V" "(setq VS (atoi $value)VSG 0 SA 0 SAG 0 DS 0 DSG 0) (modus_6331)")
(action_tile "S6331VG" "(setq VSG (atoi $value)VS 0 SA 0 SAG 0 DS 0 DSG 0) (modus_6331)")
(action_tile "S6331S" "(setq SA (atoi $value)VS 0 VSG 0 SAG 0 DS 0 DSG 0) (modus_6331)")
(action_tile "S6331SG" "(setq SAG (atoi $value)VS 0 VSG 0 SA 0 DS 0 DSG 0) (modus_6331)")
(action_tile "S6331D" "(setq DS (atoi $value)VS 0 VSG 0 SA 0 SAG 0 DSG 0) (modus_6331)")
(action_tile "S6331DG" "(setq DSG (atoi $value)VS 0 VSG 0 SA 0 SAG 0 DS 0) (modus_6331)")
(action_tile "DM" "(setq DM (atoi $value))")
(action_tile "ML" "(setq ML (atoi $value))")
(action_tile "AKR" "(setq AKR (atoi $value))")
(action_tile "hilfe" "(setq hilfe (atoi $value)) (hil)")
(action_tile "accept" 
"(if (and(or(= DS 1)(= DSG 1))(/= DM nil))(done_dialog 1))
(if (and(or(= VS 1)(= VSG 1)(= SA 1)(= SAG 1))(/= DM nil))(done_dialog 1))")

(setq OK (start_dialog))

    (if (= OK 1) (Liste_6331))

  (action_tile "cancel" "(done_dialog)")
     (unload_dialog dcl_6331)

(princ)

);end defun

;************************ Hilfedatei anzeigen ****************

(defun hil ()

(if (= hilfe 1)
    (startapp "notepad" hilf))

);end defun

;******************** Einstellungen vornehmen *********************

(defun modus_6331 ()

      (start_list "DM") (mapcar 'add_list DM_6331) (end_list)

   (cond
      ((or (= VS 1) (= VSG 1) (= SA 1) (= SAG 1))
                  (mode_tile "ML" 0) (mode_tile "AKR" 1))
      ((or (= DS 1) (= DSG 1)) (mode_tile "ML" 1) (mode_tile "AKR" 0))
   );end cond

);end defun
;********************* Durchmesser setzen *************************

(defun Liste_6331 ()

  (cond
    ((= dm 0) (setq dm 6)) ((= dm 1) (setq dm 8)) ((= dm 2) (setq dm 10))
    ((= dm 3) (setq dm 12)) ((= dm 4) (setq dm 16)) ((= dm 5) (setq dm 20))
    ((= dm 6) (setq dm 24)) ((= dm 7) (setq dm 27)) ((= dm 8) (setq dm 30))
    ((= dm 9) (setq dm 36)) ((= dm 10) (setq dm 42)) ((= dm 11) (setq dm 48))
  );end cond

 (M6331ldt)

);end defun

;************* Abmessungen whlen und Daten einlesen ***************

(Defun M6331ldt ()

(setq a1 (itoa dm)
      B  (strcat "M" a1)
      C (Read-line A))

    (If (= C nil) (setq C ""))
     (setq D C)

  (While (/= D "")

    (If (And
     (= (Substr D 1 (Strlen B)) B) (= "," (Substr D (1+ (Strlen B)) 1)))

  (progn
   (setq D "")
    (Les-din6331 1) (Les-din6331 2) (Les-din6331 3) (Les-din6331 4)
    (Les-din6331 5) (Les-din6331 6) (Les-din6331 7)

  (KWerte_6331)

 );end progn

  (progn
   (setq C (Read-line A))

    (If (= C nil) (setq C ""))
     (setq D C)
    
    );end progn
   );end if
  );end while

)end defun

;***********************Dateieintrag lesen************************

(Defun Les-din6331 (NR)

(setq D "T")

  (cond 
     ((= NR 2) (setq E "")) ((= NR 3) (setq F "")) ((= NR 4) (setq G "")) 
     ((= NR 5) (setq H "")) ((= NR 6) (setq I "")) ((= NR 7) (setq J ""))
  );end cond

  (While (/= D "")
    (setq D (Substr C 1 1))

    (If (Or (= (Ascii D) 44) (= D ""))
     (progn
      (setq D "")

    (if (/= C "")
     (setq C (Substr C 2 (- (Strlen C) 1)))
   );end if

  (cond 
     ((= NR 2) (setq E (Atof E))) ((= NR 3) (setq F (Atof F)))
     ((= NR 4) (setq G (Atof G))) ((= NR 5) (setq H (Atof H)))
     ((= NR 6) (setq I (Atof I))) ((= NR 7) (setq J (Atof J))))
  );end cond

  (progn
  
  (cond 
     ((= NR 2) (setq E (Strcat E D))) ((= NR 3) (setq F (Strcat F D)))
     ((= NR 4) (setq G (Strcat G D))) ((= NR 5) (setq H (Strcat H D)))
     ((= NR 6) (setq I (Strcat I D))) ((= NR 7) (setq J (Strcat J D)))
  )  ;end cond
   
(setq C (Substr C 2 (- (Strlen C) 1)))

   );end progn
  );end if
 );end while

);end defun

;********************** Grundeinstellungen ***********************

(defun KWerte_6331 ()

(setq aw (* pi 1.5)
      bw (* pi 2)
      cw (/ pi 2)
      dk (- F G)
      em (/ E (sin (* (/ 60.0 180) pi)))
      gwl1 (* pi (/ 190.0 180))
      gwl2 (* pi (/ 260.0 180))
      Ra (* em 0.75)
      Ls (/ em 2.0)
      hbog (- Ra (sqrt (- (* Ra Ra) (/ (* Ls Ls) 4))))
      re (/ E 2)
      rk (/ dk 2.0)
      rb (/ F 2.0))
      
   (If (<= (- F dk) 0.6)
       (setq dk (- F 0.6))
   );end if

   (cond  
     ((or (= VS 1) (= VSG 1)) (6331_VA)) ((or (= SA 1) (= SAG 1)) (6331_SA))
     ((or (= DS 1) (= DSG 1)) (6331_DS))
   );end cond

  );ende defun

;************** Konstruktionspunkte Vorderansicht ******************

(defun 6331_VA ()

(setq lmn (getvar "Limmin")      
      stp (polar lmn pi 60)
      efp (polar stp cw 150)
      p1 (polar efp bw (/ I 2.0))                        ;rechter Eckpunkt Bund
      p2 (polar p1 cw H)                                 ;rechter oberer Eckpunkt Bund
      p3 (polar p2 pi I)
      p4 (polar p3 aw H)
      p5 (polar p2 pi (/ (- I em) 2.0))
      p6 (polar p5 pi (/ em 4))
      p7 (polar p6 pi (/ em 2))
      p8 (polar p7 pi (/ em 4))
      p9 (polar p5 cw (- J H))
      p10 (polar p9 pi (/ em 8))
      p11 (polar p9 pi (/ em 2.0))
      lpa (distance p10 p11)
      p12 (polar p11 pi lpa)
      p13 (polar p9 aw hbog)
      p14 (polar p13 pi (/ em 4))
      p15 (polar p14 pi (/ em 2.0))
      p16 (polar p15 pi (/ em 4.0))
      p17 (polar efp aw 2.0)                             ;Punkt Mittellinie
      p18 (polar p11 cw 2.0)                             ;Punkt Mittellinie
      p19 (polar p11 pi (/ F 2.0))
      p20 (polar p19 cw (* G 1.5))
      p21 (polar p19 bw (/ G 2.0))
      P22 (polar p21 cw (* G 2.0))
      p23 (polar p11 bw (/ F 2.0))
      p24 (polar p23 cw (* G 1.5))
      p25 (polar p23 pi (/ G 2.0))
      p26 (polar p25 cw (* G 2.0))
      p27 (polar p11 cw (+ (* G 2.0) 2.0)))

  (cond
     ((= VS 1) (ZE_V_6331)) ((= VSG 1) (ZE_VG_6331))
  );end cond

 (altsv)

);end defun

;************** Vorderansicht ohne Bolzen zeichnen ***************

(defun ZE_V_6331 ()

(command "Layer" "SE" "SL_TB" ""
         "Linie" p1 p2 p3 p4 p1 "" "Linie" p5 p13 "" "Linie" p6 p14 ""
         "Linie" p7 p15 "" "Linie" p8 p16 "" "Linie" p12 p10 ""
         "Bogen" p13 p10 p14 "Bogen" p14 p11 p15 "Bogen" p15 p12 p16)

   (if (= ML 1)
     (command "Layer" "SE" "SLM_TB" ""
              "Linie" p17 p18 "")
    );end if

(command "layer" "SE" alay "")

     (close A)
     (blockV_6331)
   (altsv)

);ende defun 

;*************** Vorderansicht mit Bolzen zeichnen ***************

(defun ZE_VG_6331 ()

(command "Layer" "SE" "SL_TB" ""
         "Linie" p1 p2 p3 p4 p1 "" "Linie" p5 p13 "" "Linie" p6 p14 ""
         "Linie" p7 p15 "" "Linie" p8 p16 "" "Linie" p12 p10 ""
         "Linie" p19 p20 p22 p26 p24 p23 "" "Linie" p20 p24 ""
         "Bogen" p13 p10 p14 "Bogen" p14 p11 p15 "Bogen" p15 p12 p16
         "Layer" "SE" "SLD_TB" ""
         "Linie" p21 p22 "" "Linie" p25 p26 "")

   (if (= ML 1)
      (command "Layer" "SE" "SLM_TB" ""
               "Linie" p17 p27 "")
   );end if

(command "layer" "SE" alay "")
     
   (close A)
  (blockV_G_6331)
 (altsv)

);end defun

;*************** Konstruktionspunkte Seitenansicht ***************

(defun 6331_SA ()

(setq lmn (getvar "Limmin")
      stp (polar lmn pi 60)
      efp (polar stp cw 150)
      p1s (polar efp bw (/ I 2.0))                   ;rechter Eckpunkt Bund
      p2s (polar p1s cw H)                           ;rechter oberer Eckpunkt Bund
      p3s (polar p2s pi I)
      p4s (polar p3s aw H)
      p5s (polar p2s pi (/ (- I E) 2.0))
      p6s (polar p5s pi (/ E 2))
      p7s (polar p6s pi (/ E 2))
      p8s (polar p5s cw (- J H))
      p9s (polar p8s pi E)
      p10s (polar p8s aw hbog)
      p11s (polar p10s pi (/ E 2.0))
      p12s (polar p10s pi E)
      p13s (polar p8s pi (/ E 4.0))
      p14s (polar p13s pi (/ E 2.0))
      p16s (polar efp aw 2.0)
      p17s (polar efp cw (+ J 2.0))
      p18s (polar efp cw J)
      p19s (polar p18s pi (/ F 2.0))
      p20s (polar p19s cw (* G 1.5))
      p21s (polar p19s bw (/ G 2.0))
      P22s (polar p21s cw (* G 2.0))
      p23s (polar p18s bw (/ F 2.0))
      p24s (polar p23s cw (* G 1.5))
      p25s (polar p23s pi (/ G 2.0))
      p26s (polar p25s cw (* G 2.0))
      p27s (polar p18s cw (+ (* G 2.0) 2.0)))

  (cond
     ((= SA 1) (ZE_SA_6331)) ((= SAG 1) (ZE_SAG_6331))
  );end cond

);ende defun

;************** Seitenansicht ohne Bolzen zeichnen ***************

(defun ZE_SA_6331 ()

(command "Layer" "SE" "SL_TB" ""
         "Linie" p1s p2s p3s p4s p1s "" "Linie" p5s p8s p9s p7s "" 
         "Linie" p6s p11s "" "Bogen" p10s p13s p11s "Bogen" p11s p14s p12s)

   (if (= ML 1)
      (command "Layer" "SE" "SLM_TB" ""
               "Linie" p16s p17s "")
    );ende if ml

(command "layer" "SE" alay "")
     
   (close A)
  (blockV_6331)
 (altsv)

);ende defun    

;************** Seitenansicht mit Bolzen zeichnen ****************

(defun ZE_SAG_6331 ()
  
(command "Layer" "SE" "SL_TB" ""
         "Linie" p1s p2s p3s p4s p1s "" "Linie" p5s p8s p9s p7s "" 
         "Linie" p6s p11s ""  "Linie" p19s p20s p22s p26s p24s p23s "" 
         "Linie" p20s p24s "" "Bogen" p10s p13s p11s "Bogen" p11s p14s p12s
         "Layer" "SE" "SLD_TB" ""
         "Linie" p21s p22s "" "Linie" p25s p26s "")

   (if (= ML 1)
       (command "Layer" "SE" "SLM_TB" ""
                "Linie" p16s p27s "")
  );end ifl

(command "layer" "SE" alay "")
   
   (close A)
  (blockV_G_6331)
 (altsv)

);end defun

;**************** Konstruktionspunkte Draufsicht *****************

(defun 6331_DS ()

(setq lmn (getvar "Limmin")      
      stp (polar lmn pi 60)
      efp (polar stp cw 150)
      p1d (polar efp pi (/ em 2))
      p2d (polar efp aw (/ E 2.0))
      p3d (polar p2d pi (/ em 4))
      p4d (polar efp pi (+ (/ I 2) 2))
      p5d (polar p4d bw (+ I 4))
      p6d (polar efp aw (+ (/ I 2.0) 2))
      p7d (polar p6d cw (+ I 4))
      p8d (polar efp gwl1 rb)
      p9d (polar efp gwl2 rb)
      p10d (polar efp gwl1 rk)
      p11d (polar efp gwl2 rk))

   (cond
      ((= DS 1) (DA_AN_6331)) ((= DSG 1) (DAG_AN_6331))
   );end cond

);ende defun

;*************** Draufsicht ohne Bolzen zeichnen *****************

(defun DA_AN_6331 ()

(command "Layer" "SE" "SL_TB" ""
         "Kreis" efp "d" E "Kreis" efp "d" dk "Kreis" efp "d" I
         "polygon" 6 "s" p1d p3d
         "Layer" "SE" "SLD_TB" ""
         "Bogen" p9d "z" efp p8d)

   (if (= AKR 1)
      (command "Layer" "SE" "SLM_TB" ""
               "Linie" p4d p5d "" "Linie" p6d p7d "")
   );end if

(command "layer" "SE" alay "")
   
   (close A)
  (blockD_6331)
 (altsv)

);end defun

;***************** Draufsicht mit Bolzen zeichnen ****************

(defun DAG_AN_6331 ()

(command "Layer" "SE" "SL_TB" ""
         "Kreis" efp "d" E "Kreis" efp "d" F "Kreis" efp "d" I 
         "Polygon" 6 "s" p1d p3d
         "Layer" "SE" "SLD_TB" ""
         "Bogen" p11d "z" efp p10d)

  (if (= AKR 1)
     (command "Layer" "SE" "SLM_TB" ""
              "Linie" p4d p5d "" "Linie" p6d p7d "")
   );end if

 (command "layer" "SE" alay "")
   
   (close A)
  (blockD_6331)
 (altsv)

);end defun

;********* Vorder- und Seitenansicht als Block erstellen *********

(defun blockV_G_6331 ()

(setq nfile (findfile "znrtbkm.dwg")) 

  (if (= nfile nil)
    (progn

     (if (= ml 1)
       (progn

 (setq elm1 (ssget "X" '((8 . "SL_TB"))))
  (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
   (setq elm3 (ssget "X" '((8 . "SLM_TB"))))
     (sort_6331)
      (command "Wblock" "znrtbkm" "" efp elm1 elm2 elm3 "")
   );end progn
    
 (progn

  (setq elm1 (ssget "X" '((8 . "SL_TB"))))
   (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
     (sort_6331)
      (command "Wblock" "znrtbkm" "" efp elm1 elm2 "")
 
    );end progn
   );end if
  );ende progn (=nfile nil) 
 );ende if (=nfile nil)
 
 (if (/= nfile nil)
   (progn
     
     (if (= ml 1)
       (progn

 (setq elm1 (ssget "X" '((8 . "SL_TB"))))
  (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
    (setq elm3 (ssget "X" '((8 . "SLM_TB"))))
     (sort_6331)
      (command "Wblock" "znrtbkm" "J" "" efp elm1 elm2 elm3 "")
   );end progn
    
 (progn

  (setq elm1 (ssget "X" '((8 . "SL_TB"))))
   (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
     (sort_6331)
      (command "Wblock" "znrtbkm" "J" "" efp elm1 elm2 "")

    );end progn
   );end if
  );ende progn (/=nfile nil)
 );ende if (/=nfile nil)

(setq elm1 nil elm2 nil elm3 nil)
 (einf_6331) 

  (altsv)
);end defun

;********* Vorder- und Seitenansicht als Block erstellen *********

(defun blockV_6331 ()

(setq nfile (findfile "znrtbkm.dwg")) 

  (if (= nfile nil)
    (progn

     (if (= ml 1)
       (progn

 (setq elm1 (ssget "X" '((8 . "SL_TB"))))
  (setq elm2 (ssget "X" '((8 . "SLM_TB"))))
     (sort_6331)
      (command "Wblock" "znrtbkm" "" efp elm1 elm2 "")
   );end progn
    
 (progn

  (setq elm1 (ssget "X" '((8 . "SL_TB"))))
     (sort_6331)
      (command "Wblock" "znrtbkm" "" efp elm1 "")

    );end progn
   ) ;end if
  );ende if (=nfile nil) 
 );ende progn (=nfile nil)
 
 (if (/= nfile nil)
   (progn
     
     (if (= ml 1)
       (progn

 (setq elm1 (ssget "X" '((8 . "SL_TB"))))
  (setq elm2 (ssget "X" '((8 . "SLM_TB"))))
   (sort_6331)
    (command "Wblock" "znrtbkm" "J" "" efp elm1 elm2 "")
   );end progn
    
 (progn

  (setq elm1 (ssget "X" '((8 . "SL_TB"))))
   (sort_6331)
    (command "Wblock" "znrtbkm" "J" "" efp elm1 "")

    );end progn
   );end if
  );ende if (/=nfile nil)
 );ende progn (/=nfile nil)

(setq elm1 nil eim2 nil)
 (einf_6331) 

  (altsv)
);ende defun einfVS

;************** Draufsicht Mutter als Block erstellen ************

(defun blockD_6331 ()

(setvar "Limcheck" 0)

(setq nfile (findfile "znrtbkm.dwg")) 

  (if (= nfile nil)
    (progn

     (if (= AKR 1)
       (progn

 (setq elm1 (ssget "X" '((8 . "SL_TB"))))
  (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
   (setq elm3 (ssget "X" '((8 . "SLM_TB"))))
    (sort_6331)
     (command "Wblock" "znrtbkm" "" efp elm1 elm2 elm3"")
   );end progn
    
 (progn

  (setq elm1 (ssget "X" '((8 . "SL_TB"))))
   (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
    (sort_6331)
     (command "Wblock" "znrtbkm" "" efp elm1 elm2 "")

    );end progn
   ) ;end if
  );end if (= nfile nil) 
 );end progn (= nfile nil)

 (if (/= nfile nil)
   (progn
     
     (if (= AKR 1)
       (progn

 (setq elm1 (ssget "X" '((8 . "SL_TB"))))
  (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
   (setq elm3 (ssget "X" '((8 . "SLM_TB"))))
    (sort_6331)
     (command "Wblock" "znrtbkm" "J" "" efp elm1 elm2 elm3 "")
   );end progn
    
 (progn

  (setq elm1 (ssget "X" '((8 . "SL_TB"))))
   (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
    (sort_6331)
     (command "Wblock" "znrtbkm" "J" "" efp elm1 elm2 "")

    );end progn
   );end if
  );end if (/= nfile nil)
 );end progn (/= nfile nil)

(setq elm1 nil elm2 nil elm3 nil)
 (einf_6331) 

  (altsv)

);end defun

;******************* Vorhandene Blcke auflisten *****************

(defun sort_6331 (/ Zeichtbkm Zahltbkm)

  (setq Count 0)
   (setq ele_tbkm (tblnext "block" T))
  
  (while (/= nil ele_tbkm)

    (setq Zeichtbkm (substr (cdr (assoc 2 ele_tbkm)) 1 8))
    
  (cond 
     ((= Zeichtbkm "ZNR6331-")
        (setq Zahltbkm (atoi (substr (cdr (assoc 2 ele_tbkm)) 9 3))))
  );end cond
    
        (if (> Zahltbkm Count)
           (setq Count Zahltbkm)
        );end if

    (setq ele_tbkm (tblnext "block" ))
  );ende while
 
);ende defun

;******************** Element als Block einfgen *****************

(defun Einf_6331 ()
 
 (setq count  (1+ count))
  (setq counts (itoa count))

   (while (/= (strlen counts) 3)
       (setq counts (strcat "0" counts))
   );end while

 (setq blockef (strcat "ZNR6331-" counts "=znrtbkm"))

 (setvar "cmdecho" 1)
    (command "_insert" blockef pause "" "" pause)
  
  (altsv)

);ende defun

;*********************** Programmende ************************

(prompt "\n DIN_6331.lsp geladen. Mit Eingabe  MU6331  und RETURN starten.")
(princ)
