;  Programm: "DIN_985.lsp" zeichnet Sechskantmuttern mit Klemmteil
;            in Vorderansicht, Seitenansicht und Draufsicht.
;
;  Erforderliche Zusatzdatei: DIN_985.ldt
;                             din_985.slb
;                             DIN_985.dcl
;
;  Programmautor: Karl Maurer  (C)  1998
;
;  Einsatzbereich: AutoCAD 12,13,14 DOS/Windows/NT.
;
;  Anmerkung: Das Programm erzeugt selbstndig die Layer "SLD_TB", "SLM_TB"
;             und "SL_TB" und zeichnet die einzelnen Zeichnungslelemente auf
;             diese Layer.
;
;             Gewindelinien auf "SLD_TB"
;             Mittellinien auf "SLM_TB"
;             Alle anderen Linien auf "SL_TB".
;
;  Alle vorher eingestellten Systemvariablen die durch dieses Programm
;  verndert wurden, werden bei Abbruch oder Verlassen des Programmes
;  automatisch wieder zurckgesetzt.
;
;****************************************************************
(prompt "\n DIN_985.lsp wird geladen.")

(Defun C:MU985 ( / A B C D E F G H I VS VSG SA SAG DS DSG aw bw cw dk em bohv 
                  AKR ML DM ncd dcl p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 p11 p12 p13 
                  p14 p15 p16 p17 p18 p19 p20 p21 p22 p23 p24 p25 p26 p27 p28 
                  p29 p30 p31 p32 p33 p34 p35 p36 p37 p38 p39 p40 p41 p42 p43 
                  p44 p45 p1d p2d p3d p4d p5d p6d p7d p8d p9d p10d p11d p12d 
                  p13d dcl_985 slb vz Bre Hoe ele_tbkm count counts blockef
                  gwl1 gwl2 dcl_985)

(setq cm (getvar "cmdecho"))
(setq bl (getvar "blipmode"))
(setq os (getvar "osmode"))
(setq alay (getvar "clayer"))
(setq lmc (getvar "limcheck"))

(setvar "cmdecho" 0)
(setvar "blipmode" 0)
(setvar "Limcheck" 0)
(setvar "osmode" 0)
(tb_layer)
)

(defun altsv ()
(setvar "blipmode" bl)
(setvar "osmode" os)
(setvar "cmdecho" cm)
(setvar "Limcheck" lmc)
)

(defun *error* (emsg)
(princ emsg)
(close A)
(altsv)
(princ)
)

;************************** Layer erzeugen *************************

(defun tb_layer ()

(command "Layer" "M" "SL_TB" "FA" "7" "" "LT" "" "SL_TB" ""
         "Layer" "M" "SLM_TB" "FA" "2" "" "LT" "Mitte" "SLM_TB" ""
         "Layer" "M" "SLD_TB" "FA" "2" "" "LT" "" "SLD_TB" "")

(command "layer" "SE" alay "")

  (Start_985)

);end defun

;*********************** Zusatzdatei ffnen ***********************

(defun Start_985 ()

(setq ncd (findfile "din_985.ldt"))

    (If (= Nil ncd)
      (progn
       (princ "Datei din_985.ldt kann nicht geffnet werden!")
        (setq vz (getstring t "\n Verzeichnis der Zusatzdatei eingeben: "))
          (setq A (Open (strcat "/" vz "/" "din_985.ldt") "r"))
     );end progn
   );end if

   (if ncd (setq A (Open ncd "r")) )

 (MU985_dcl)

);end defun

;************ DCL-Box aufrufen und Abmessungen whlen *************

(defun MU985_dcl ()

(setq dcl (findfile "DIN_985.dcl"))
 (setq slb (findfile "din_985.slb"))
  (setq dcl_985 (load_dialog "DIN_985.dcl")) 
   (if (not (new_dialog "DIN_985" dcl_985)) (exit) ) 
    (setq hilf (findfile "din_985.hil"))

(setq DM_985 (list " M5" " M6" " M7" " M8" " M10" " M12" " M14" " M16" " M18" 
               " M20" " M22" " M24" " M27" " M30" " M33" " M36" " M39"
               " M42" " M45" " M48"))

(setq Bre (dimx_tile "S985V"))
(setq Hoe (dimy_tile "S985V"))
(start_image "S985V")
(slide_image 0 0 bre hoe "din_985(DIN985V)")
(end_image)

(setq Bre (dimx_tile "S985VG"))
(setq Hoe (dimy_tile "S985VG"))
(start_image "S985VG")
(slide_image 0 0 bre hoe "din_985(DIN985VG)")
(end_image)

(setq Bre (dimx_tile "S985S"))
(setq Hoe (dimy_tile "S985S"))
(start_image "S985S")
(slide_image 0 0 bre hoe "din_985(DIN985S)")
(end_image)

(setq Bre (dimx_tile "S985SG"))
(setq Hoe (dimy_tile "S985SG"))
(start_image "S985SG")
(slide_image 0 0 bre hoe "din_985(DIN985SG)")
(end_image)

(setq Bre (dimx_tile "S985D"))
(setq Hoe (dimy_tile "S985D"))
(start_image "S985D")
(slide_image 0 0 bre hoe "din_985(DIN985D)")
(end_image)

(setq Bre (dimx_tile "S985DG"))
(setq Hoe (dimy_tile "S985DG"))
(start_image "S985DG")
(slide_image 0 0 bre hoe "din_985(DIN985DG)")
(end_image)

(action_tile "S985V" "(setq VS (atoi $value) VSG 0 SA 0 SAG 0 DS 0 DSG 0)(mode_t985)")
(action_tile "S985VG" "(setq VSG (atoi $value) VS 0 SA 0 SAG 0 DS 0 DSG 0)(mode_t985)")
(action_tile "S985S" "(setq SA (atoi $value) VS 0 VSG 0 SAG 0 DS 0 DSG 0)(mode_t985)")
(action_tile "S985SG" "(setq SAG (atoi $value) VS 0 VSG 0 SA 0 DS 0 DSG 0)(mode_t985)")
(action_tile "S985D" "(setq DS (atoi $value) VS 0 VSG 0 SA 0 SAG 0 DSG 0)(mode_t985)")
(action_tile "S985DG" "(setq DSG (atoi $value) VS 0 VSG 0 SA 0 SAG 0 DS 0)(mode_t985)")
(action_tile "DM" "(setq DM (atoi $value)) (durm_985) ")
(action_tile "ML" "(setq ML (atoi $value))")
(action_tile "AKR" "(setq AKR (atoi $value))")
(action_tile "hilfe" "(setq hilfe (atoi $value)) (hil)")
(action_tile "accept" 
"(if (and(or(= DS 1)(= DSG 1))(/= DM nil))(done_dialog 1))
(if (and(or(= VS 1)(= VSG 1)(= SA 1)(= SAG 1))(/= DM nil))(done_dialog 1))")

(setq OK (start_dialog))

    (if (= OK 1) (Dat-DIN985))

(action_tile "cancel" "(done_dialog)")
  (unload_dialog dcl_985)

(princ)

);end defun

;************************ Hilfedatei anzeigen ****************

(defun hil ()

(if (= hilfe 1)
    (startapp "notepad" hilf))

);end defun

;******************** Einstellungen zurcksetzen *****************

(defun mode_t985 ()

  (cond
     ((or (= VS 1) (= VSG 1) (= SA 1) (= SAG 1))(mode_tile "AKR" 1) 
          (mode_tile "ML" 0)(start_list "DM") (mapcar 'add_list DM_985) (end_list))
     ((or (= DS 1) (= DSG 1))(mode_tile "AKR" 0)(mode_tile "ML" 1)
          (start_list "DM") (mapcar 'add_list DM_985) (end_list))
  );cond

);end defun

;************************ Durchmesser bestimmen ********************

(defun durm_985 ()

 (cond
    ((= dm 0) (setq dm 5)) ((= dm 1) (setq dm 6)) ((= dm 2) (setq dm 7))
    ((= dm 3) (setq dm 8)) ((= dm 4) (setq dm 10)) ((= dm 5) (setq dm 12))
    ((= dm 6) (setq dm 14)) ((= dm 7) (setq dm 16)) ((= dm 8) (setq dm 18))
    ((= dm 9) (setq dm 20)) ((= dm 10) (setq dm 22)) ((= dm 11) (setq dm 24))
    ((= dm 12) (setq dm 27)) ((= dm 13) (setq dm 30)) ((= dm 14) (setq dm 33))
    ((= dm 15) (setq dm 36)) ((= dm 16) (setq dm 39)) ((= dm 17) (setq dm 42))
    ((= dm 18) (setq dm 45)) ((= dm 19) (setq dm 48))
 );end cond

);end defun

;************************* Daten einlesen ************************

(Defun DAT-DIN985 ()

(setq a1 (itoa dm)
      B  (strcat "M" a1)
      C (Read-line A))

    (If (= C nil) (setq C ""))
     (setq D C)

  (While (/= D "")

    (If (And (= (Substr D 1 (Strlen B)) B) (= "," (Substr D (1+ (Strlen B)) 1)) )

  (progn
   (setq D "")

    (Les-din985 1) (Les-din985 2) (Les-din985 3) (Les-din985 4) (Les-din985 5) 
    (Les-din985 6)

    (DIN-985_EW)
 );end progn

  (progn
   (setq C (Read-line A))

    (If (= C nil) (setq C ""))
     (setq D C)

   );end progn
  );end if 
 );end while

);end defun

;**************************** Daten umwandeln **********************

(Defun Les-din985 (NR)

(setq D "T")

  (cond 
     ((= NR 2) (setq E "")) ((= NR 3) (setq F "")) ((= NR 4) (setq G ""))
     ((= NR 5) (setq H "")) ((= NR 6) (setq I ""))
  );end cond

  (While (/= D "")
    (setq D (Substr C 1 1))

    (If (Or (= (Ascii D) 44) (= D ""))
     (progn
      (setq D "")

    (if (/= C "") (setq C (Substr C 2 (- (Strlen C) 1))) )

  (cond 
     ((= NR 2) (setq E (Atof E))) ((= NR 3) (setq F (Atof F)))
     ((= NR 4) (setq G (Atof G))) ((= NR 5) (setq H (Atof H)))
     ((= NR 6) (setq I (Atof I)))
  );end cond
 );end progn

  (progn

    (cond 
      ((= NR 2) (setq E (Strcat E D))) ((= NR 3) (setq F (Strcat F D)))
      ((= NR 4) (setq G (Strcat G D))) ((= NR 5) (setq H (Strcat H D)))
      ((= NR 6) (setq I (Strcat I D)))
  );end cond

   (setq C (Substr C 2 (- (Strlen C) 1)))

   );end progn
  );end if
 );end while

);end defun

;************** Konstruktionspunkte setzen ************************

(Defun DIN-985_EW ()

(setq aw (* pi 1.5)
      bw (* pi 2)
      cw (/ pi 2)
      gwl1 (* pi (/ 190 180.0))
      gwl2 (* pi (/ 260 180.0))
      dk (- F G)
      em (/ E (sin(* (/ 60.0 180) pi)))
      bohv (- em (sqrt (- (* em em) (* (* (/ em 2) (/ em 2)) 0.30))))
      r (/ E 2)
      rk (/ dk 2.0)
      rb (/ F 2.0) )

   (If (<= (- F dk) 0.6)
       (setq dk (- F 0.6))
   );end if

  (985VA_KP)

);end defun

;************************ Vorderansicht ***************************

(defun 985VA_KP()

(setq lmn (getvar "Limmin")
      stp (polar lmn pi 100)
      efp (polar stp cw 100)
      p1 (polar efp bw (* em 0.375))
      p2 (polar p1 cw H)
      p3 (polar efp cw H)
      p4 (polar p3 pi (* em 0.375))
      p5 (polar p4 aw H)
      p6 (polar efp cw bohv)
      p7 (polar p6 bw (/ em 4))
      p8 (polar p7 bw (/ em 4))
      p9 (polar p8 cw (- H (* bohv 2.0)))
      p10 (polar p9 pi (/ em 4))
      p11 (polar p10 pi (/ em 2))
      p12 (polar p11 pi (/ em 4))
      p13 (polar p6 pi (/ em 2))
      p14 (polar p6 pi (/ em 4))
      p15 (polar efp cw I)
      p16 (polar p15 pi (/ E 2.0))
      p17 (polar p16 aw (* (- I H) 1.048))
      p18 (polar p15 bw (/ E 2.0))
      p19 (polar p17 bw E)
      p20 (polar p15 pi (/ F 2.0))
      p21 (polar p15 pi (/ dk 2.0))
      p23 (polar p15 bw (/ F 2.0))
      p24 (polar p15 bw (/ dk 2.0))
      p25 (polar p20 cw (- (* G 3.0) (/ (- F dk) 2.0)))
      p26 (polar p21 cw (* G 3.0))
      p27 (polar p26 bw dk)
      p28 (polar p25 bw F)
      p29 (polar efp aw 2)
      p30 (polar p15 cw 2)
      p31 (polar p15 cw (+ (* G 3.0) 2))
      p32 (polar efp bw (/ E 2.0))             ;Punkte fr Seitenansicht
      p33 (polar p32 cw H)
      p34 (polar p33 pi E)
      p35 (polar p34 aw H)
      p36 (polar efp cw bohv)
      p37 (polar p36 bw (/ E 2.0))
      p38 (polar p36 pi (/ E 2.0))
      p39 (polar p33 aw bohv)
      p40 (polar p39 pi (/ E 2.0))
      p41 (polar p39 pi E)
      p42 (polar efp bw (/ E 4.0))
      p43 (polar p42 cw H)
      p44 (polar p43 pi (/ E 2.0))
      p45 (polar p44 aw H)
      p1d (polar efp pi (/ em 2))         ;Punkte fr Draufsicht
      p2d (polar efp aw (/ E 2.0))
      p3d (polar p2d pi (/ em 4))
      p4d (polar efp pi (+ (/ em 2) 2))
      p5d (polar p4d bw (+ em 4))
      p6d (polar efp aw (+ (/ E 2.0) 2))
      p7d (polar p6d cw (+ E 4))
      p8d (polar efp gwl1 rb)
      p9d (polar efp gwl2 rb)
      p10d (polar efp gwl1 rk)
      p11d (polar efp gwl2 rk) )

  (cond 
    ((= VS 1) (VS_AN_985)) ((= VSG 1) (VSG_AN_985)) ((= SA 1) (SA_AN_985))
    ((= SAG 1) (SAG_AN_985)) ((= DS 1) (DA_AN_985)) ((= DSG 1) (DAG_AN_985))
  );end cond      

  (altsv)

);end defun

;************** Vorderansicht ohne Bolzen zeichnen ***************

(defun VS_AN_985 ()

(command "Layer" "SE" "SL_TB" ""
         "Plinie" p8 "B" 0 0  p9 "K" "P" p2 p10 "K" p10 "P" p3 p11 
         "K" p11 "P" p4 p12 "LI" p13 "K" "P" p5 p14 "K" p14 "P" efp p7 
         "K" p7 "P" p1 p8 "" "Linie" p7 p10 "" "Linie" p14 p11 "" 
         "Linie" p17 p16 p18 p19 "" "Linie" p2 p4 "" "Linie" p1 p5 "")

   (if (= ml 1)
      (command "Layer" "SE" "SLM_TB" ""
               "Linie" p29 p30"")
  );end if

(command "layer" "SE" alay "")
    
    (close A)
   (blockVS_985)
  (altsv) 

);end defun

;************* Vorderansicht mit Bolzen zeichnen *****************

(defun VSG_AN_985 ()

(command "Layer" "SE" "SL_TB" ""
         "Plinie" p8 "B" 0 0 p9 "K" "P" p2 p10 "K" p10 "P" p3 p11 
         "K" p11 "P" p4 p12 "LI" p13 "K" "P" p5 p14 "K" p14 "P" efp p7 
         "K" p7 "P" p1 p8 "" "Linie" p7 p10 "" "Linie" p14 p11 "" 
         "Linie" p17 p16 p18 p19 "" "Linie" p2 p4 "" "Linie" p1 p5 ""
         "Plinie" p20 "B" 0 0 p25 p26 p27 p28 p23 "" "Linie" p25 p28 ""
         "Layer" "SE" "SLD_TB" ""
         "Linie" p21 p26 "" "Linie" p24 p27 "")
   
   (if (= ml 1)
      (command "Layer" "SE" "SLM_TB" ""
               "Linie" p29 p31 "")
  );end if
   
(command "layer" "SE" alay "")
    
    (close A)
   (blockVS_G_985)
  (altsv)

);end defun

;*************** Seitenansicht ohne Bolzen zeichnen **************

(defun SA_AN_985 ()

(command "Layer" "SE" "SL_TB" ""
         "Linie" p32 p33 p34 p35 p32 "" "Linie" p36 p40 ""
         "Linie" p34 p16 p18 p33 "" "Bogen" p36 p42 p37 "Bogen" p39 p43 p40 
         "Bogen" p40 p44 p41 "Bogen" p38 p45 p36)

   (if (= ml 1)
      (command "Layer" "SE" "SLM_TB" ""
               "Linie" p29 p30 "")
  );end if
   
(command "layer" "SE" alay "")
     
     (close A)
    (blockVS_985)
   (altsv)

);end defun

;************** Seitenansicht Bolzen zeichnen ********************

(defun SAG_AN_985 ()

(command "Layer" "SE" "SL_TB" ""
         "Linie" p32 p33 p34 p35 p32 "" "Linie" p36 p40 ""
         "Linie" p34 p16 p18 p33 "" "Bogen" p36 p42 p37 "Bogen" p39 p43 p40 
         "Bogen" p40 p44 p41 "Bogen" p38 p45 p36
         "Linie" p20 p25 p26 p27 p28 p23 "" "Linie" p25 p28 ""
         "Layer" "SE" "SLD_TB" ""
         "Linie" p21 p26 "" "Linie" p24 p27 "")
   
   (if (= ml 1)
      (command "Layer" "SE" "SLM_TB" ""
               "Linie" p29 p31 "")
  );end if
   
(command "layer" "SE" alay "")
    
    (close A)
   (blockVS_G_985)
  (altsv)

);end defun

;*************** Draufsicht ohne Bolzen zeichnen *****************

(defun DA_AN_985 ()

(command "Layer" "SE" "SL_TB" ""
         "Kreis" efp "d" E "Kreis" efp "d" dk "polygon" 6 "s" p1d p3d
         "Layer" "SE" "SLD_TB" ""
         "Bogen" p9d "z" efp p8d )


    (if (= AKR 1)
       (command "Layer" "SE" "SLM_TB" ""
                "Linie" p4d p5d "" "Linie" p6d p7d "")
   );end if

(command "layer" "SE" alay "")
   
   (close A)
  (blockDS_985)
 (altsv)

);emd defun

;***************** Draufsicht mit Bolzen zeichnen ****************

(defun DAG_AN_985 ()

(command "Layer" "SE" "SL_TB" ""
         "Kreis" efp "d" E "Kreis" efp "d" F "Polygon" 6 "s" p1d p3d
         "Layer" "SE" "SLD_TB" ""
         "Bogen" p11d "z" efp p10d)

   (if (= AKR 1)
      (command "Layer" "SE" "SLM_TB" ""
               "Linie" p4d p5d "" "Linie" p6d p7d "")
   );end if
   
(command "layer" "SE" alay "")
   
    (close A)
   (blockDS_985)
  (altsv)

);end defun

;********* Vorder- und Seitenansicht als Block erstellen *********

(defun blockVS_G_985 ()

(setvar "Limcheck" 0)

(setq nfile (findfile "znrtbkm.dwg")) 

  (if (= nfile nil)
    (progn

     (if (= ml 1)
       (progn

 (setq elm1 (ssget "X" '((8 . "SL_TB"))))
  (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
   (setq elm3 (ssget "X" '((8 . "SLM_TB"))))
     (sort_985)
      (command "Wblock" "znrtbkm" "" efp elm1 elm2 elm3 "")
   );end progn
    
 (progn

  (setq elm1 (ssget "X" '((8 . "SL_TB"))))
   (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
     (sort_985)
      (command "Wblock" "znrtbkm" "" efp elm1 elm2 "")

    );end progn
   );end if
  );end progn (=nfile nil) 
 );end if (=nfile nil)
 
 (if (/= nfile nil)
   (progn
     
     (if (= ml 1)
       (progn

 (setq elm1 (ssget "X" '((8 . "SL_TB"))))
  (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
    (setq elm3 (ssget "X" '((8 . "SLM_TB"))))
     (sort_985)
      (command "Wblock" "znrtbkm" "J" "" efp elm1 elm2 elm3 "")
   );end progn
    
 (progn

  (setq elm1 (ssget "X" '((8 . "SL_TB"))))
   (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
     (sort_985)
      (command "Wblock" "znrtbkm" "J" "" efp elm1 elm2 "")

    );end progn
   );end if
  );end progn (/=nfile nil)
 );end if (/=nfile nil)

(setq elm1 nil elm2 nil elm3 nil)
 (einf_985) 
 
  (altsv)

);end defun

;********* Vorder- und Seitenansicht als Block erstellen *********

(defun blockVS_985 ()

(setq nfile (findfile "znrtbkm.dwg")) 

  (if (= nfile nil)
    (progn

     (if (= ml 1)
       (progn

 (setq elm1 (ssget "X" '((8 . "SL_TB"))))
  (setq elm2 (ssget "X" '((8 . "SLM_TB"))))
     (sort_985)
      (command "Wblock" "znrtbkm" "" efp elm1 elm2 "")
   );end progn
    
 (progn

  (setq elm1 (ssget "X" '((8 . "SL_TB"))))
     (sort_985)
      (command "Wblock" "znrtbkm" "" efp elm1 "")

    );end progn
   ) ;end if
  );end progn(=nfile nil) 
 );end if (=nfile nil)
 
 (if (/= nfile nil)
   (progn
     
     (if (= ml 1)
       (progn

 (setq elm1 (ssget "X" '((8 . "SL_TB"))))
  (setq elm2 (ssget "X" '((8 . "SLM_TB"))))
     (sort_985)
      (command "Wblock" "znrtbkm" "J" "" efp elm1 elm2 "")
   );end progn
    
 (progn

  (setq elm1 (ssget "X" '((8 . "SL_TB"))))
     (sort_985)
      (command "Wblock" "znrtbkm" "J" "" efp elm1 "")

    );end progn
   );end if
  );end progn (/=nfile nil)
 );end if (/=nfile nil)

 (setq elm1 nil elm2 nil)
   (einf_985) 
 
  (altsv)

);end defun

;************** Draufsicht Mutter als Block erstellen ************

(defun blockDS_985 ()

(setq nfile (findfile "znrtbkm.dwg")) 

  (if (= nfile nil)
    (progn

     (if (= AKR 1)
       (progn

 (setq elm1 (ssget "X" '((8 . "SL_TB"))))
  (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
   (setq elm3 (ssget "X" '((8 . "SLM_TB"))))
    (sort_985)
     (command "Wblock" "znrtbkm" "" efp elm1 elm2 elm3"")
   );end progn
    
 (progn

  (setq elm1 (ssget "X" '((8 . "SL_TB"))))
   (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
    (sort_985)
     (command "Wblock" "znrtbkm" "" efp elm1 elm2 "")

    );end progn
   );end if
  );end progn (= nfile nil) 
 );end if (= nfile nil)

 (if (/= nfile nil)
   (progn
     
     (if (= AKR 1)
       (progn

 (setq elm1 (ssget "X" '((8 . "SL_TB"))))
  (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
   (setq elm3 (ssget "X" '((8 . "SLM_TB"))))
    (sort_985)
     (command "Wblock" "znrtbkm" "J" "" efp elm1 elm2 elm3 "")
   );end progn
    
 (progn

  (setq elm1 (ssget "X" '((8 . "SL_TB"))))
   (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
    (sort_985)
     (command "Wblock" "znrtbkm" "J" "" efp elm1 elm2 "")

    );end progn
   );end if
  );end progn (/= nfile nil)
 );end if (/= nfile nil)

 (setq elm1 nil elm2 nil elm3 nil)
   (einf_985) 
 
  (altsv)

);end defun

;******************* Vorhandene Blcke auflisten *****************

(defun sort_985 (/ Zeichtbkm Zahltbkm)

  (setq count 0)
   (setq ele_tbkm (tblnext "block" T))
  
  (while (/= nil ele_tbkm)

    (setq Zeichtbkm (substr (cdr (assoc 2 ele_tbkm)) 1 7))
    
  (cond 
     ((= Zeichtbkm "ZNR985-")
        (setq Zahltbkm (atoi (substr (cdr (assoc 2 ele_tbkm)) 8 3))))
  );end cond
    
        (if (> Zahltbkm Count)
           (setq Count Zahltbkm)
        );end if

    (setq ele_tbkm (tblnext "block" ))
  );end while
 
);end defun

;******************** Element als Block einfgen *****************

(defun einf_985 ()
 
 (setq count  (1+ count))
  (setq counts (itoa count))

  (while (/= (strlen counts) 3)
     (setq counts (strcat "0" counts))
  );end while

 (setq blockef (strcat "ZNR985-" counts "=znrtbkm"))
  (setvar "cmdecho" 1)
   (command "_insert" blockef pause "" "" pause)
  
  (altsv)

);end defun

;**************************** Programmende *********************

(prompt "\n DIN_985.lsp geladen. Mit Eingabe MU985 und RETURN starten.")
(princ)
