
;  Programm: "EN24017" zeichnet Schrauben hnlich DIN EN 24017 in 
;            Vorderansicht, Seitenansicht und Draufsicht.
;
;  Erforderliche Datei: EN24017.ldt
;                       EN24017.dcl
;                       en24017.slb
;
;  Programmiert von: Karl Maurer   (C) 1998
;
;  Einsatzbereich: AutoCAD 12,13,14 DOS/Windows/NT
;
;  Anmerkung: Durch das Programm werden Layer erzeugt und die einzelnen 
;             Zeichnungselemente auf diese Layer gezeichnet.
;             Gewindelinien auf "SLD_TB"
;             Mittellinien auf "SLM_TB"
;             Alle anderen Linien auf "SL_TB".
;
;  Alle vorher eingestellten Systemvariablen die durch dieses Programm
;  verndert wurden, werden bei Abruch oder Verlassen des Programmes
;  automatisch wieder zurckgesetzt.
;
;************************** Programmbeginn ************************

(prompt "\n Bitte warten.. EN24017.lsp wird geladen.")

(defun C:S4017 ( / A B C D E F G H I LG DM VS VSK DV SA SAK DS TA a1 a2 em dk 
                 akr efp p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 p11 p12 p13 p14 p15 
                 p16 p17 p18 p19 p20 p21 p22 p24 p25 p26 p27 p28 p29 p30 p31 
                 p32 p33 p34 p35 p36 p37 p38 p39 p40 p41 p42 p434 p44 p45 p46 
                 p47 p48 p49 p50 p51 aw bw cw ncd vz dcl slb ml ele_tbkm 
                 blockef count counts dcl_id)

(setq cm (getvar "cmdecho"))
(setq bl (getvar "blipmode"))
(setq os (getvar "osmode"))
(setq alay (getvar "clayer"))
(setq lmc (getvar "Limcheck"))

(setvar "cmdecho" 0)
(setvar "blipmode" 0)
(setvar "osmode" 0)
(setvar "Limcheck" 0)
(tb_layer)
);ende defun c

(defun *error* (emsg)
(princ emsg)
(altsv)
(princ)
)
(defun altsv ()
(setvar "blipmode" bl)
(setvar "osmode" os)
(setvar "cmdecho" cm)
(setvar "Limcheck" lmc)
)

;************************** Layer erzeugen *************************

(defun tb_layer ()

(command "Layer" "M" "SL_TB" "FA" "7" "" "LT" "" "SL_TB" ""
         "Layer" "M" "SLM_TB" "FA" "2" "" "LT" "Mitte" "SLM_TB" ""
         "Layer" "M" "SLD_TB" "FA" "2" "" "LT" "" "SLD_TB" "")

(command "layer" "SE" alay "")

  (Start_24017)

);end defun

;************************ Zusatzdatei ffnen ***********************

(defun Start_24017 ()

(setq ncd (findfile "en24017.ldt"))
    
    (If (= Nil ncd)
      (progn
        (princ "Datei en24017.ldt kann nicht geffnet werden!")
(setq vz (getstring t "\n Verzeichnis der Zusatzdatei eingeben: "))
  (setq A (Open (strcat "/" vz "/" "en24017.ldt") "r"))
   );end progn
  );end if

     (if ncd (setq A (Open ncd "r"))) 
 
 (S24017_dcl)
);ende defun

;************************ DCL-Datei starten ************************

(defun S24017_dcl ()

(setq dcl (findfile "EN24017.dcl"))
 (setq slb (findfile "en24017.slb"))
  (setq dcl_24017 (load_dialog "EN24017.dcl")) 
   (if (not (new_dialog "EN24017" dcl_24017)) (exit))
    (setq hilf (findfile "en24017.hil"))

(setq DM24017 (list " M3" " M4" " M5" " M6" " M8" " M10" " M12" " (M14)" 
                    " M16" " (M18)" " M20" " (M22)" " M24" " (M27)" " M30" 
                    " (M33)" " M36" " (M39)" " M42" " (M45)" " M48" " (M52)" 
                    " M56" " (M60)" " M64"))

(setq LM3 (List " 6" " 8" " 10" " 12" " 16" " 20" " 25" " 30"))

(setq LM4 (List " 8" " 10" " 12" " 16" " 20" " 25" " 30" " 35" " 40"))

(setq LM5 (List " 10" " 12" " 16" " 20" " 25" " 30" " 35" " 40" " 45" " 50"))

(setq LM6 (List " 12" " 16" " 20" " 25" " 30" " 35" " 40" " 45" " 50" " 55" 
                " 60"))
                                    
(setq LM8 (List " 16" " 20" " 25" " 30" " 35" " 40" " 45" " 50" " 55" " 60" 
                " 65" " 70" " 80"))

(setq LM10 (List " 20" " 25" " 30" " 35" " 40" " 45" " 50" " 55" " 60" " 65" 
                 " 70" " 80" " 90" " 100"))

(setq LM12 (List " 25" " 30" " 35" " 40" " 45" " 50" " 55" " 60" " 65" " 70" 
                 " 80" " 90" " 100" " 110" " 120"))

(setq LM14 (List " 30" " 35" " 40" " 45" " 50" " 55" " 60" " 65" " 70" " 80" 
                 " 90" " 100" " 110" " 120" " 130" " 140"))

(setq LM16 (List " 30" " 35" " 40" " 45" " 50" " 55" " 60" " 65" " 70" " 80" 
                 " 90" " 100" " 110" " 120" " 130" " 140" " 150" " 160"))

(setq LM18 (List " 35" " 40" " 45" " 50" " 55" " 60" " 65" " 70" " 80" " 90" 
                 " 100" " 110" " 120" " 130" " 140" " 150"  " 160" " 180"))

(setq LM20 (List " 40" " 45" " 50" " 55" " 60" " 65" " 70" " 80" " 90" " 100" 
                 " 110" " 120" " 130" " 140" " 150" " 160" " 180" " 200"))

(setq LM22 (List " 45" " 50" " 55" " 60" " 65" " 70" " 80" " 90" " 100" 
                 " 110" " 120" " 130" " 140" " 150" " 160" " 180" " 200"))

(setq LM24 (List " 50" " 55" " 60" " 65" " 70" " 80" " 90" " 100" " 110" 
                 " 120" " 130" " 140" " 150" " 160" " 180" " 200"))

(setq LM27 (List " 55" " 60" " 65" " 70" " 80" " 90" " 100" " 110" " 120" 
                 " 130" " 140" " 150" " 160" " 180" " 200"))

(setq LM30 (List " 60" " 65" " 70" " 80" " 90" " 100" " 110" " 120" " 130" 
                 " 140" " 150" " 160" " 180" " 200"))

(setq LM33 (List " 65" " 70" " 80" " 90" " 100" " 110" " 120" " 130" " 140" 
                 " 150" " 160" " 180" " 200"))

(setq LM36 (List " 70" " 80" " 90" " 100" " 110" " 120" " 130" " 140" " 150" 
                 " 160" " 180" " 200"))

(setq LM39 (List " 80" " 90" " 100" " 110" " 120" " 130" " 140" " 150" " 160" 
                 " 180" " 200"))

(setq LM42 (List " 80" " 90" " 100" " 110" " 120" " 130" " 140" " 150" " 160" 
                 " 180" " 200"))

(setq LM45 (List " 90" " 100" " 110" " 120" " 130" " 140" " 150" " 160" " 180" 
                 " 200"))

(setq LM48 (List " 100" " 110" " 120" " 130" " 140" " 150" " 160" " 180" 
                 " 200"))

(setq LM52 (List " 100" " 110" " 120" " 130" " 140" " 150" " 160" " 180" 
                 " 200"))

(setq LM56 (List " 110" " 120" " 130" " 140" " 150" " 160" " 180" " 200"))

(setq LM60 (List " 120" " 130" " 140" " 150" " 160" " 180" " 200"))

(setq LM64 (List " 120" " 130" " 140" " 150" " 160" " 180" " 200"))

(setq Bre (dimx_tile "24017V"))
(setq Hoe (dimy_tile "24017V" ))
(start_image "24017V")
(slide_image 0 0 bre hoe "en24017(din4017V)")
(end_image)

(setq Bre (dimx_tile "24017VK"))
(setq Hoe (dimy_tile "24017VK"))
(start_image "24017VK")
(slide_image 0 0 bre hoe "en24017(din4017VK)")
(end_image)

(setq Bre (dimx_tile "24017DV"))
(setq Hoe (dimy_tile "24017DV"))
(start_image "24017DV")
(slide_image 0 0 bre hoe "en24017(din4017VD)")
(end_image)

(setq Bre (dimx_tile "24017S"))
(setq Hoe (dimy_tile "24017S" ))
(start_image "24017S")
(slide_image 0 0 bre hoe "en24017(din4017S)")
(end_image)

(setq Bre (dimx_tile "24017SK"))
(setq Hoe (dimy_tile "24017SK"))
(start_image "24017SK")
(slide_image 0 0 bre hoe "en24017(din4017SK)")
(end_image)

(setq Bre (dimx_tile "24017DS"))
(setq Hoe (dimy_tile "24017DS"))
(start_image "24017DS")
(slide_image 0 0 bre hoe "en24017(din4017SD)")
(end_image)

(action_tile "24017V"  "(setq VS (atoi $value) VSK 0 DV 0 SA 0 SAK 0 DS 0)
                        (mode_t_4017)")
(action_tile "24017VK" "(setq VSK (atoi $value) VS 0 DV 0 SA 0 SAK 0 DS 0)
                        (mode_t_4017)")
(action_tile "24017DV" "(setq DV (atoi $value) VS 0 VSK 0 SA 0 SAK 0 DS 0)
                        (mode_t_4017)")
(action_tile "24017S"  "(setq SA (atoi $value) VS 0 VSK 0 DV 0 SAK 0 DS 0)
                        (mode_t_4017)") 
(action_tile "24017SK" "(setq SAK (atoi $value) VS 0 VSK 0 DV 0 SA 0 DS 0)
                        (mode_t_4017)") 
(action_tile "24017DS" "(setq DS (atoi $value) VS 0 VSK 0 DV 0 SA 0 SAK 0)
                        (mode_t_4017)") 
(action_tile "DM" "(setq DM (atoi $value)) (durm_24017)")
(action_tile "LG" "(setq LG (atoi $value)) (Lngen_24017)")
(action_tile "ML" "(setq ML (atoi $value))")
(action_tile "AKR" "(setq AKR (atoi $value))")
(action_tile "TA" "(setq TA (atoi $value))")
(action_tile "hilfe" "(setq hilfe (atoi $value)) (hil)")
(action_tile "accept"
"(if (and (and (/= DM nil)(/= LG nil)) (or (= VS 1) (= SA 1)))(done_dialog 1))
(if (and (and (/= DM nil)(= LG nil)) (or (= VS 1) (= SA 1)))(start_mode))
(if (and (or (= VSK 1)(= SAK 1)(= DV 1)(= DS 1))(/= DM nil))(done_dialog 1))")

(setq OK (start_dialog))

     (if (= OK 1) (DAT_24017))

(action_tile "cancel" "(done_dialog)")
 (unload_dialog dcl_24017)

 (princ)
);defun

;************************ Hilfedatei anzeigen ****************

(defun hil ()

(if (= hilfe 1)
    (startapp "notepad" hilf))

);end defun

;*************************** Startmodus *************************

(defun start_mode ()

(alert "Sie haben noch keine Schraubenlnge gewhlt!\n
Whlen Sie bitte eine Schraubenlnge!")
);end defun
;********************** Modus einstellen *************************

(defun mode_t_4017 ()

   (cond
      ((or (= VS 1) (= VSK 1) (= SA 1) (= SAK 1))
            (mode_tile "AKR" 1) (mode_tile "ML" 0) (mode_tile "TA" 0)) 
   );cond

 (cond
      ( (or (= DV 1) (= DS 1))
            (mode_tile "AKR" 0) (mode_tile "ML" 1) (mode_tile "TA" 1)) 
 );cond

  (DM_list_4017)
);defun

;********************** Lngen auflisten *************************

(defun DM_list_4017 ()

   (cond
      ((or (= VS 1) (= VSK 1) (= DV 1) (= SA 1) (= SAK 1) (= DS 1))
            (start_list "DM") (mapcar 'add_list DM24017) (end_list))
   );cond

);defun

;************************ Durchmesser bestimmen ********************

(defun durm_24017 ()

  (cond
    ((= dm 0) (setq dm 3)) ((= dm 1) (setq dm 4)) ((= dm 2) (setq dm 5))
    ((= dm 3) (setq dm 6)) ((= dm 4) (setq dm 8)) ((= dm 5) (setq dm 10))
    ((= dm 6) (setq dm 12)) ((= dm 7) (setq dm 14)) ((= dm 8) (setq dm 16)) 
    ((= dm 9) (setq dm 18)) ((= dm 10) (setq dm 20)) ((= dm 11) (setq dm 22)) 
    ((= dm 12) (setq dm 24)) ((= dm 13) (setq dm 27)) ((= dm 14) (setq dm 30)) 
    ((= dm 15) (setq dm 33)) ((= dm 16) (setq dm 36)) ((= dm 17) (setq dm 39)) 
    ((= dm 18) (setq dm 42)) ((= dm 19) (setq dm 45)) ((= dm 20) (setq dm 48)) 
    ((= dm 21) (setq dm 52)) ((= dm 22) (setq dm 56)) ((= dm 23) (setq dm 60)) 
    ((= dm 24) (setq dm 64))
  );cond

  (cond  
    ((or (= VS 1) (= SA 1)) (DM_List_24017))
  );cond

);ende defun

;****************** Durchmesserliste anzeigen *******************

(defun DM_List_24017 ()

(start_list "LG")

  (cond
     ( (= dm 3) (mapcar 'add_list LM3) (setq diff 0))
     ( (= dm 4) (mapcar 'add_list LM4) (setq diff 1))
     ( (= dm 5) (mapcar 'add_list LM5) (setq diff 2))
     ( (= dm 6) (mapcar 'add_list LM6) (setq diff 3))
     ( (= dm 8) (mapcar 'add_list LM8) (setq diff 4))
     ( (= dm 10) (mapcar 'add_list LM10) (setq diff 5))
     ( (= dm 12) (mapcar 'add_list LM12) (setq diff 6))
     ( (= dm 14) (mapcar 'add_list LM14) (setq diff 7))
     ( (= dm 16) (mapcar 'add_list LM16) (setq diff 7))
     ( (= dm 18) (mapcar 'add_list LM18) (setq diff 8))
     ( (= dm 20) (mapcar 'add_list LM20) (setq diff 9))
     ( (= dm 22) (mapcar 'add_list LM22) (setq diff 10))
     ( (= dm 24) (mapcar 'add_list LM24) (setq diff 11))
     ( (= dm 27) (mapcar 'add_list LM27) (setq diff 12))
     ( (= dm 30) (mapcar 'add_list LM30) (setq diff 13))
     ( (= dm 33) (mapcar 'add_list LM33) (setq diff 14))
     ( (= dm 36) (mapcar 'add_list LM36) (setq diff 15))
     ( (= dm 39) (mapcar 'add_list LM39) (setq diff 16))
     ( (= dm 42) (mapcar 'add_list LM42) (setq diff 16))
     ( (= dm 45) (mapcar 'add_list LM45) (setq diff 17))
     ( (= dm 48) (mapcar 'add_list LM48) (setq diff 18))
     ( (= dm 52) (mapcar 'add_list LM52) (setq diff 18))
     ( (= dm 56) (mapcar 'add_list LM56) (setq diff 19))
     ( (= dm 60) (mapcar 'add_list LM60) (setq diff 20))
     ( (= dm 64) (mapcar 'add_list LM64) (setq diff 20))
  );end cond

  (end_list) 

 );end defun

;*********************** Lngen bestimmen ********************

(defun Lngen_24017 ()

(setq lg (+ lg diff))

(cond
 ((= Lg 0) (setq Lg 6)) ((= Lg 1) (setq Lg 8)) ((= Lg 2) (setq LG 10))
 ((= Lg 3) (setq Lg 12)) ((= Lg 4) (setq Lg 16)) ((= Lg 5) (setq LG 20))
 ((= Lg 6) (setq Lg 25)) ((= Lg 7) (setq Lg 30)) ((= Lg 8) (setq LG 35))
 ((= Lg 9) (setq Lg 40)) ((= Lg 10) (setq Lg 45)) ((= Lg 11) (setq LG 50))
 ((= Lg 12) (setq Lg 55)) ((= Lg 13) (setq Lg 60)) ((= Lg 14) (setq LG 65)) 
 ((= Lg 15) (setq Lg 70)) ((= Lg 16) (setq Lg 80)) ((= Lg 17) (setq LG 90)) 
 ((= Lg 18) (setq Lg 100)) ((= Lg 19) (setq Lg 110)) ((= Lg 20) (setq Lg 120)) 
 ((= Lg 21) (setq Lg 130)) ((= Lg 22) (setq Lg 140)) ((= Lg 23) (setq LG 150)) 
 ((= Lg 24) (setq Lg 160)) ((= Lg 25) (setq Lg 180)) ((= Lg 26) (setq LG 200)) 
 );end cond

 );ende defun

;************************* Daten einlesen **********************

(Defun DAT_24017 ()

   (if (or (= VSK 1) (= DV 1) (= SAK 1) (= DS 1)) 
       (setq LG 0)
   );end if

(setq a1 (itoa dm)
      a2 (itoa lg)
      B (strcat "M" a1 "." a2)
      C (Read-line A))
  
    (If (= C nil)
     (setq C ""))
      (setq D C)
  
  (While (/= D "")

    (If (And
     (= (Substr D 1 (Strlen B)) B) (= "," (Substr D (1+ (Strlen B)) 1)))
  
  (progn
   (setq D "")

     (Les_24017 1) (Les_24017 2) (Les_24017 3) (Les_24017 4) (Les_24017 5) 
     (Les_24017 6) (Les_24017 7) (Les_24017 8) 

     (KWerte_4017)
  );end progn
  
  (progn
    (setq C (Read-line A))
  
    (If (= C nil) (setq C ""))
     (setq D C)
  
   );end progn
  );end if
 );end while

);end defun

;************************ Daten umwandeln *********************

(Defun Les_24017 (NR)

(setq D "T")

   (cond 
      ((= NR 2) (setq E "")) ((= NR 3) (setq F "")) ((= NR 4) (setq G "")) 
      ((= NR 5) (setq H "")) ((= NR 6) (setq I "")) ((= NR 7) (setq J ""))
      ((= NR 8) (setq K ""))
   );end cond
  
  (While (/= D "")
   (setq D (Substr C 1 1))
  
    (If (Or (= D ",") (= D ""))
  
  (progn
   (setq D "")
  
    (if (/= C "")
     (setq C (Substr C 2 (- (Strlen C) 1)))
    );end if
  
  (cond 
     ((= NR 2) (setq E (Atof E))) ((= NR 3) (setq F (Atof F)))
     ((= NR 4) (setq G (Atof G))) ((= NR 5) (setq H (Atof H)))
     ((= NR 6) (setq I (Atof I))) ((= NR 7) (setq J (Atof J)))
     ((= NR 8) (setq K (Atof K)))
   );emd cond
  );end progn
  
  (progn

  (cond 
     ((= NR 2) (setq E (Strcat E D))) ((= NR 3) (setq F (Strcat F D)))
     ((= NR 4) (setq G (Strcat G D))) ((= NR 5) (setq H (Strcat H D)))
     ((= NR 6) (setq I (Strcat I D))) ((= NR 7) (setq J (Strcat J D)))
     ((= NR 8) (setq K (Strcat K D)))
  );end cond

 (setq C (Substr C 2 (- (Strlen C) 1)))
 
  );end progn
  );end if
 );end while

);end defun

;****************** Konstruktionspunkte setzen *********************

(DEFUN KWerte_4017 ()

(setq aw (* pi 1.5) 
      bw (* pi 2) 
      cw (/ pi 2)
      em (/ E (sin(* (/ 60.0 180) pi)))   
      dk (- F G)
      bohv (- em (sqrt (- (* em em) (* (* (/ em 2) (/ em 2)) 0.30)))) )
 
    (if (< (- F dk) 0.6)
      (setq dk (- F 0.6))
    );end if
 
 (24017_KP)

);ende defun

;***************** Konstruktionspunkte bestimmen ******************

(defun 24017_KP ()

(setq Lmn (getvar "Limmin")  
      stp (polar lmn pi 70)
      efp (polar stp cw 200)
      p1 (polar efp cw I)
      p2 (polar efp bw (/ em 4.0))
      p3 (polar efp bw (/ em 2.0))
      p4 (polar p3 cw (- I bohv))
      p5 (polar p4 pi (/ em 4.0))
      p6 (polar p5 pi (/ em 2.0))
      p7 (polar p6 pi (/ em 4.0))
      p8 (polar efp pi (/ em 2.0))
      p9 (polar efp pi (/ em 4.0))
      p10 (polar p1 bw (* (/ em 8.0) 3.0))
      p11 (polar p1 pi (* (/ em 8.0) 3.0))
      p12 (polar efp pi (/ F 2.0))
      p13 (polar p12 aw 2.5)
      p14 (polar p13 bw (/ (- F dk) 2.0))
      p15 (polar p14 bw dk)
      p16 (polar p13 bw F)
      p17 (polar p12 aw (- H (/ (- F dk) 2.0)))
      p18 (polar p14 aw (- H 2.5))
      p19 (polar p18 bw dk)
      p20 (polar p17 bw F)
      p21 (polar p12 bw F)
      p22 (polar efp aw (+ H 2.0))                  ;Punkt fr Mittellinie
      p23 (polar p1 cw 2)                           ;Punkt fr Mittellinie
      p24 (polar efp bw (/ E 2.0))
      p25 (polar p24 cw I)
      p26 (polar p25 pi E)
      p27 (polar p26 aw I)
      p28 (polar p25 aw bohv) 
      p29 (polar p28 pi (/ E 2.0))
      p30 (polar p29 pi (/ E 2.0))
      p31 (polar p25 pi (/ E 4.0))
      p32 (polar p31 pi (/ E 2.0))
      p33 (polar efp pi (+ (/ em 2.0) 2.0)) ;Punkte fr Achsenkreuz Draufsicht
      p34 (polar efp bw (+ (/ em 2.0) 2.0))
      p35 (polar efp cw (+ (/ E 2.0) 2.0))
      p36 (polar efp aw (+ (/ E 2.0) 2.0))
      p37 (polar efp aw 2.0)                ;Punkt fr Mittellinie Schraubenkopf
      p38 (polar efp pi (/ K 2.0))
      p39 (polar efp bw (/ K 2.0))
      p40 (polar p38 cw J)
      p41 (polar p39 cw J)
      p42 (polar p8 cw J)
      p43 (polar p9 cw J)
      p44 (polar p2 cw J)
      p45 (polar p3 cw J)
      p46 (polar efp pi (/ K 2.0))
      p47 (polar efp bw (/ K 2.0))
      p48 (polar p46 cw J)
      p49 (polar p47 cw J)
      p50 (polar p27 cw J)
      p51 (polar efp cw J)
      p52 (polar p24 cw J)
);ende setq

 (cond
     ((= VS 1) (ZE_VS_4017)) ((= VSK 1) (ZE_VSK_4017)) ((= SA 1) (ZE_SA_4017))
     ((= SAK 1) (ZE_SAK_4017)) ((= DV 1) (ZE_DV_4017)) ((= DS 1) (ZE_DV_4017))
 );end cond

);ende defun

;******************** Vorderansicht zeichnen ********************

(defun ZE_VS_4017 ()

  (if (= TA 1)
    (progn

(command "Layer" "SE" "SL_TB" ""
         "Linie" p40 p38 p39 p41 ""
         "Linie" p7 p42 p45 p4 "" "Linie" p43 p6 "" "Linie" p44 p5 ""
         "Linie" p10 p11 "" "Linie" p12 p17 p18 p19 p20 p21 "" 
         "Linie" p13 p16 "" "Linie" p17 p20 "" "Bogen" p4 p10 p5
         "Bogen" p5 p1 p6 "Bogen" p6 p11 p7
         "Layer" "SE" "SLD_TB" ""
         "Linie" p14 p18 "" "Linie" p19 p15 "")
     );end progn

(command "Layer" "SE" "SL_TB" ""
         "Linie" p7 p8 p3 p4 "" "Linie" p9 p6 "" "Linie" p2 p5 ""
         "Linie" p10 p11 "" "Linie" p12 p17 p18 p19 p20 p21 "" 
         "Linie" p13 p16 "" "Linie" p17 p20 "" "Bogen" p4 p10 p5
         "Bogen" p5 p1 p6 "Bogen" p6 p11 p7
         "Layer" "SE" "SLD_TB" ""
         "Linie" p14 p18 "" "Linie" p19 p15 "")
  );end if

    (if (= ML 1)
       (command "Layer" "SE" "SLM_TB" ""
         "Linie" p22 p23 "")
    );end if

(command "Layer" "SE" alay "")

    (close A)
   (blockVS_4017)
  (altsv)
);ende defun

;************* Nur Kopf der Vorderansicht zeichnen ***************

(defun ZE_VSK_4017 ()

   (if (= TA 1)
     (progn

(command "Layer" "SE" "SL_TB" ""
         "Linie" p40 p38 p39 p41 ""
         "Linie" p7 p42 p45 p4 "" "Linie" p43 p6 "" "Linie" p44 p5 ""
         "Linie" p10 p11 "" "Bogen" p4 p10 p5 "Bogen" p5 p1 p6 
         "Bogen" p6 p11 p7)
     );end progn


(command "Layer" "SE" "SL_TB" ""
         "Linie" p7 p8 p3 p4 "" "Linie" p9 p6 "" "Linie" p2 p5 ""
         "Linie" p10 p11 "" "Bogen" p4 p10 p5 "Bogen" p5 p1 p6 
         "Bogen" p6 p11 p7)
  );end if

    (if (= ML 1)
      (command "Layer" "SE" "SLM_TB" ""
               "Linie" p37 p23 "")
    );end if

(command "Layer" "SE" alay "")

    (close A)
   (blockVSK_4017)
  (altsv)

);ende defun

;******************* Seitenansicht zeichnen **********************

(defun ZE_SA_4017 ()

   (if (= TA 1)
     (progn

(command "Layer" "SE" "SL_TB" ""
         "Linie" p40 p38 p39 p41 ""
         "Linie" p26 p50 p52 p25 p26 "" "Linie" p51 p29 ""
         "Linie" p12 p17 p18 p19 p20 p21 "" "Linie" p13 p16 "" 
         "Linie" p17 p20 "" "Bogen" p28 p31 p29 "Bogen" p29 p32 p30
         "Layer" "SE" "SLD_TB" ""
         "Linie" p14 p18 "" "Linie" p19 p15 "")
     );end progn

(command "Layer" "SE" "SL_TB" ""
         "Linie" p24 p25 p26 p27 p24 "" "Linie" efp p29 ""
         "Linie" p10 p11 "" "Linie" p12 p17 p18 p19 p20 p21 "" 
         "Linie" p13 p16 "" "Linie" p17 p20 "" "Bogen" p28 p31 p29 
         "Bogen" p29 p32 p30
         "Layer" "SE" "SLD_TB" ""
         "Linie" p14 p18 "" "Linie" p19 p15 "")
  );end if

    (if (= ML 1)
      (command "Layer" "SE" "SLM_TB" ""
         "Linie" p22 p23 "")
    );end if

(command "Layer" "SE" alay "")

    (close A)
   (blockVS_4017)
  (altsv)

);ende defun

;************** Nur Kopf der Seitenansicht zeichnen **************

(defun ZE_SAK_4017 ()

   (if (= TA 1)
     (progn

(command "Layer" "SE" "SL_TB" ""
         "Linie" p40 p38 p39 p41 ""
         "Linie" p26 p50 p52 p25 p26 "" "Linie" p51 p29 ""
         "Bogen" p28 p31 p29 "Bogen" p29 p32 p30)
     );end progn

(command "Layer" "SE" "SL_TB" ""
         "Linie" p24 p25 p26 p27 p24 "" "Linie" efp p29 ""
         "Bogen" p28 p31 p29 "Bogen" p29 p32 p30)
   );end if

    (if (= ml 1)
       (command "Layer" "SE" "SLM_TB" ""
         "Linie" p37 p23 "")
    );end if

(command "Layer" "SE" alay "")

    (close A)
   (blockVSK_4017)
  (altsv)

);ende defun

;************************** Draufsicht ************************

(defun ZE_DV_4017 ()


(command "Layer" "SE" "SL_TB" ""
         "polygon" 6 efp "U" (/ em 2.0)  "Kreis" efp "D" E )

    (if (= AKR 1)
      (command "Layer" "SE" "SLM_TB" ""
               "Linie" p33 p34 "" "Linie" p35 p36 "")
    );end if

(command "Layer" "SE" alay "")

    (close A)
   (blockDS_4017)
  (altsv)

);ende defun

;**************** Schraube als Block erstellen *******************

(defun blockVS_4017 ()

(setq nfile (findfile "znrtbkm.dwg")) 

  (if (= nfile nil)
    (progn

     (if (= ML 1)
       (progn

 (setq elm1 (ssget "X" '((8 . "SL_TB"))))
  (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
   (setq elm3 (ssget "X" '((8 . "SLM_TB"))))
    (sort_4017)
     (command "Wblock" "znrtbkm" "" efp elm1 elm2 elm3 "")
   );end progn
    
 (progn

  (setq elm1 (ssget "X" '((8 . "SL_TB"))))
   (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
    (sort_4017)
     (command "Wblock" "znrtbkm" "" efp elm1 elm2 "")

    );end progn
   ) ;end if
  );end progn (=nfile nil) 
 );end if (=nfile nil)
 
 (if (/= nfile nil)
   (progn
     
     (if (= ML 1)
       (progn

 (setq elm1 (ssget "X" '((8 . "SL_TB"))))
  (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
   (setq elm3 (ssget "X" '((8 . "SLM_TB"))))
    (sort_4017)
     (command "Wblock" "znrtbkm" "J" "" efp elm1 elm2 elm3 "")
   );end progn
    
 (progn

  (setq elm1 (ssget "X" '((8 . "SL_TB"))))
   (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
    (sort_4017)
     (command "Wblock" "znrtbkm" "J" "" efp elm1 elm2 "")

    );end progn
   );end if
  );end progn (/=nfile nil)
 );end if (/=nfile nil)

 (setq elm1 nil elm2 nil elm3 nil)
  (einf_4017) 

 (altsv)

);ende defun

;************** Schraubenkopf als Block erstellen *****************

(defun blockVSK_4017 ()

(setq nfile (findfile "znrtbkm.dwg")) 

  (if (= nfile nil)
    (progn

     (if (= ML 1)
       (progn

 (setq elm1 (ssget "X" '((8 . "SL_TB"))))
  (setq elm2 (ssget "X" '((8 . "SLM_TB"))))
   (sort_4017)
    (command "Wblock" "znrtbkm" "" efp elm1 elm2 "")
   );end progn
    
 (progn

  (setq elm1 (ssget "X" '((8 . "SL_TB"))))
   (sort_4017)
    (command "Wblock" "znrtbkm" "" efp elm1 "")

     );end progn
    );end if
   );end progn (= nfile nil) 
  );end if (= nfile nil)
 
 (if (/= nfile nil)
   (progn
     
     (if (= ML 1)
       (progn

 (setq elm1 (ssget "X" '((8 . "SL_TB"))))
  (setq elm2 (ssget "X" '((8 . "SLM_TB"))))
   (sort_4017)
    (command "Wblock" "znrtbkm" "J" "" efp elm1 elm2 "")
   );end progn
    
    (progn

  (setq elm1 (ssget "X" '((8 . "SL_TB"))))
   (sort_4017)
    (command "Wblock" "znrtbkm" "J" "" efp elm1 "")

    );end progn
   );end if
  );end progn (/= nfile nil)
 );end if (/= nfile nil)

 (setq elm1 nil elm2 nil)
  (einf_4017)
  
 (altsv)

);ende defun einfK

;**************** Draufsicht als Block erstellen ******************

(defun blockDS_4017 ()

(setvar "Limcheck" 0)

(setq nfile (findfile "znrtbkm.dwg")) 

  (if (= nfile nil)
    (progn

     (if (= AKR 1)
       (progn

 (setq elm1 (ssget "X" '((8 . "SL_TB"))))
  (setq elm2 (ssget "X" '((8 . "SLM_TB"))))
   (sort_4017)
    (command "Wblock" "znrtbkm" "" efp elm1 elm2 "")
  );ende progn (= AK 1)
    
 (progn

  (setq elm1 (ssget "X" '((8 . "SL_TB"))))
   (sort_4017)
   (command "Wblock" "znrtbkm" "" efp elm1 "")

    );end progn
   );end if 
  );end progn (= nfile nil) 
 );end if (= nfile nil)
 
 (if (/= nfile nil)
   (progn
     
     (if (= AKR 1)
       (progn

 (setq elm1 (ssget "X" '((8 . "SL_TB"))))
  (setq elm2 (ssget "X" '((8 . "SLM_TB"))))
   (sort_4017)
    (command "Wblock" "znrtbkm" "J" "" efp elm1 elm2 "")
   );end progn
    
 (progn

  (setq elm1 (ssget "X" '((8 . "SL_TB"))))
   (sort_4017)
    (command "Wblock" "znrtbkm" "J" "" efp elm1 "")

     );end progn
    );end if
   );end progn (/= nfile nil)
  );end if (/= nfile nil)

 (setq elm1 nil elm2 nil)
  (einf_4017) 
  
 (altsv)

);ende defun

;******************* Vorhandene Blcke auflisten *****************

(defun sort_4017 (/ Zeichtbkm Zahltbkm)

  (setq Count 0)
   (setq ele_tbkm (tblnext "block" T))
  
  (while (/= nil ele_tbkm)

    (setq Zeichtbkm (substr (cdr (assoc 2 ele_tbkm)) 1 9))
    
   (cond    
     ((= Zeichtbkm "ZNR24017-")
        (setq Zahltbkm (atoi (substr (cdr (assoc 2 ele_tbkm)) 10 3))))
   );end cond

        (if (> Zahltbkm Count)
           (setq Count Zahltbkm))

     (setq ele_tbkm (tblnext "block" ))
  );ende while
 
);ende defun

;******************** Element als Block einfgen *****************

(defun einf_4017 ()
 
 (setq count  (1+ count))
  (setq counts (itoa count))

   (while (/= (strlen counts) 3)
       (setq counts (strcat "0" counts))
   );end while

 (setq blockef (strcat "ZNR24017-" counts "=znrtbkm"))

 (setvar "cmdecho" 1)

  (cond 
     ((= DS 1) (command "_insert" blockef pause "" "" 90))
     ((or (= VS 1) (= VSK 1) (= SA 1) (= SAK 1))
                  (command "_insert" blockef pause "" "" pause))
     ((= DV 1) (command "_insert" blockef pause "" "" ""))  
  );end cond
  
 (altsv)

);ende defun

;************************** Programmende ********************

(Prompt "\nEN24017.lsp geladen. Mit Eingabe  S4017  und RETURN starten")
(princ)
