;  Programm: "EN24032.lsp" zeichnet Sechskantmuttern mit und ohne
;            Telleransatz hnlich DIN EN 24032 in Vorderansicht, 
;            Seitenansicht und Draufsicht von M3 bis M64.
;
;  Erforderliche Zusatzdatei: EN24032.ldt
;                             EN24032.slb
;                             EN24032.dcl
;
;  Programmiert von: Karl Maurer  (C)  1998
;
;  Einsatzbereich: AutoCAD 12,13,14 DOS/Windows/NT.
;
;  Anmerkung: Das Programm erzeugt die Layer "SL_TB" "SLD_TB" "SLM_TB"
;             und zeichnet die eizelnen Elemente auf diese Layer.
;
;             Gewindelinien auf "SLD_TB"
;             Mittellinien auf "SLM_TB"
;             Alle anderen Linien auf "SL_TB".
;
;  Alle vorher eingestellten Systemvariablen die durch dieses Programm
;  verndert wurden, werden bei Abbruch oder Verlassen des Programmes
;  automatisch wieder zurckgesetzt.
;
;************************* Programmbeginn *********************

(prompt "\n EN24032.lsp wird geladen.")

(Defun C:MU4032 ( / A B C D E F G H I VS VSG SA SAG DS DSG TA aw bw cw dk em bohv 
                     AKR ML DM ncd dcl p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 p11 p12 p13 
                     p14 p15 p16 p17 p18 p19 p20 p21 p22 p23 p24 p25 p26 p27 p28 p29 
                     p30 p31 p32 p33 p34 p35 p36 p37 p38 p39 p40 p41 p42 p43 p44 p45 
                     p46 p47 p48 p49 p50 p1d p2d p3d p4d p5d p6d p7d p8d p9d p10d p11d 
                     dcl_24032 slb vz ele_tbkm count counts blockef gwl1 gwl2)

(setq cm (getvar "cmdecho"))
(setq bl (getvar "blipmode"))
(setq os (getvar "osmode"))
(setq alay (getvar "clayer"))
(setq lmc (getvar "limcheck"))

(setvar "cmdecho" 0)
(setvar "blipmode" 0)
(setvar "Limcheck" 0)
(setvar "osmode" 0)
(tb_layer)
)

(defun altsv ()
(setvar "blipmode" bl)
(setvar "osmode" os)
(setvar "cmdecho" cm)
(setvar "Limcheck" lmc)
)

(defun *error* (emsg)
(princ emsg)
(close A)
(altsv)
(princ)
)

;************************** Layer erzeugen *************************

(defun tb_layer ()

(command "Layer" "M" "SL_TB" "FA" "7" "" "LT" "" "SL_TB" ""
         "Layer" "M" "SLM_TB" "FA" "2" "" "LT" "Mitte" "SLM_TB" ""
         "Layer" "M" "SLD_TB" "FA" "2" "" "LT" "" "SLD_TB" "")

(command "layer" "SE" alay "")

  (Start_24032)

);end defun

;*********************** Zusatzdatei ffnen ***********************

(defun Start_24032 ()

(setq ncd (findfile "EN24032.ldt"))

    (If (= Nil ncd)
      (progn
     (princ "Datei EN24032.ldt kann nicht geffnet werden!")
      (setq vz (getstring t "\n Verzeichnis der Zusatzdatei eingeben: "))
       (setq A (Open (strcat "/" vz "/" "EN24032.ldt") "r"))
     );ende progn
   );ende if

     (if ncd
       (setq A (Open ncd "r"))
    );end if

 (MU24032_dcl)

);ende defun

;************ DCL-Box aufrufen und Abmessungen whlen *************

(defun MU24032_dcl ()

(setq dcl (findfile "EN24032.dcl"))
 (setq slb (findfile "en24032.slb"))
  (setq dcl_24032 (load_dialog "EN24032.dcl")) 
   (if (not (new_dialog "EN24032" dcl_24032)) (exit) ) 
    (setq hilf (findfile "en24032.hil"))

(setq DM_24032 (list " M3" " M4" " M5" " M6" " M8" " M10" " M12" " (M14)" " M16" 
               " (M18)" " M20" " (M22)" " M24" " (M27)" " M30" " (M33)"
               " M36" " (M39)" " M42" " (M45)" " M48" " (M52)" " M56"
               " (M60)" " M64"))

(setq Bre (dimx_tile "24032V"))
(setq Hoe (dimy_tile "24032V"))
(start_image "24032V")
(slide_image 0 0 bre hoe "en24032(din4032V)")
(end_image)

(setq Bre (dimx_tile "24032S"))
(setq Hoe (dimy_tile "24032S"))
(start_image "24032S")
(slide_image 0 0 bre hoe "en24032(din4032S)")
(end_image)

(setq Bre (dimx_tile "24032D"))
(setq Hoe (dimy_tile "24032D"))
(start_image "24032D")
(slide_image 0 0 bre hoe "en24032(din4032DS)")
(end_image)

(setq Bre (dimx_tile "24032VG"))
(setq Hoe (dimy_tile "24032VG"))
(start_image "24032VG")
(slide_image 0 0 bre hoe "en24032(din4032VG)")
(end_image)

(setq Bre (dimx_tile "24032SG"))
(setq Hoe (dimy_tile "24032SG"))
(start_image "24032SG")
(slide_image 0 0 bre hoe "en24032(din4032SG)")
(end_image)

(setq Bre (dimx_tile "24032DG"))
(setq Hoe (dimy_tile "24032DG"))
(start_image "24032DG")
(slide_image 0 0 bre hoe "en24032(din4032DG)")
(end_image)

(action_tile "24032V" "(setq VS (atoi $value) VST 0 VSG 0 VSGT 0 SA 0 SAT 0 
                      SAG 0 SAGT 0 DS 0 DSG 0 DST 0 DSGT 0) (mode_t_4032)")
(action_tile "24032VG" "(setq VSG (atoi $value) VST 0 VS 0 VSGT 0 SA 0 SAT 0 
                      SAG 0 SAGT 0 DS 0 DSG 0 DST 0 DSGT 0) (mode_t_4032)")
(action_tile "24032S" "(setq SA (atoi $value) VST 0 VSG 0 VSGT 0 VS 0 SAT 0 
                      SAG 0 SAGT 0 DS 0 DSG 0 DST 0 DSGT 0) (mode_t_4032)")
(action_tile "24032SG" "(setq SAG (atoi $value) VST 0 VSG 0 VSGT 0 SA 0 SAT 0 
                       VS 0 SAGT 0 DS 0 DSG 0 DST 0 DSGT 0) (mode_t_4032)")
(action_tile "24032D" "(setq DS (atoi $value) VST 0 VSG 0 VSGT 0 SA 0 SAT 0 
                      SAG 0 SAGT 0 VS 0 DSG 0 DST 0 DSGT 0) (mode_t_4032)")
(action_tile "24032DG" "(setq DSG (atoi $value) VST 0 VSG 0 VSGT 0 SA 0 SAT 0 
                      SAG 0 SAGT 0 DS 0 VS 0 DST 0 DSGT 0) (mode_t_4032)")
(action_tile "DM" "(setq DM (atoi $value)) (durm_24032) ")
(action_tile "ML" "(setq ML (atoi $value))")
(action_tile "AKR" "(setq AKR (atoi $value))")
(action_tile "TA" "(setq TA (atoi $value))")
(action_tile "hilfe" "(setq hilfe (atoi $value)) (hil)")
(action_tile "accept" "(if (/= DM nil) (done_dialog 1))")

(setq OK (start_dialog))

    (if (= OK 1) (Dat_24032))

(action_tile "cancel" "(done_dialog)")
  (unload_dialog dcl_24032)

 (princ)
);ende defun

;************************ Hilfedatei anzeigen ****************

(defun hil ()

(if (= hilfe 1)
    (startapp "notepad" hilf))

);end defun

;*********************** Modus einstellen ***********************

(defun mode_t_4032 ()

  (cond
     ((or (= VS 1) (= VSG 1) (= SA 1) (= SAG 1)) (mode_tile "ML" 0) 
          (mode_tile "AKR" 1) (mode_tile "TA" 0))
     ((or (= DS 1) (= DSG 1)) (mode_tile "ML" 1) (mode_tile "AKR" 0)
                              (mode_tile "TA" 1))
  );end cond

 (dml_24032)

);end defun

;********************* Durchmesserliste anzeigen *****************

(defun dml_24032 ()

(start_list "DM")

  (cond
     ((or (= VS 1) (= VST 1) (= VSG 1) (= VSGT 1) (= SA 1) (= SAT 1)
          (= SAG 1) (= SAGT 1) (= DS 1) (= DSG 1) (= DST 1) (= DSGT 1))
          (mapcar 'add_list DM_24032))
  );end cond

 (end_list)

);end defun

;*********************** Durchmesser bestimmen *******************

(defun durm_24032 ()

 (cond
    ((= dm 0) (setq dm 3)) ((= dm 1) (setq dm 4)) ((= dm 2) (setq dm 5))
    ((= dm 3) (setq dm 6)) ((= dm 4) (setq dm 8)) ((= dm 5) (setq dm 10))
    ((= dm 6) (setq dm 12)) ((= dm 7) (setq dm 14)) ((= dm 8) (setq dm 16))
    ((= dm 9) (setq dm 18)) ((= dm 10) (setq dm 20)) ((= dm 11) (setq dm 22))
    ((= dm 12) (setq dm 24)) ((= dm 13) (setq dm 27)) ((= dm 14) (setq dm 30))
    ((= dm 15) (setq dm 33)) ((= dm 16) (setq dm 36)) ((= dm 17) (setq dm 39))
    ((= dm 18) (setq dm 42)) ((= dm 19) (setq dm 45)) ((= dm 20) (setq dm 48))
    ((= dm 21) (setq dm 52)) ((= dm 22) (setq dm 56)) ((= dm 23) (setq dm 60))
    ((= dm 24) (setq dm 64)) 
 );end cond

);end defun

;************************* Daten einlesen ************************

(defun DAT_24032 ()

(setq a1 (itoa dm)
      B  (strcat "M" a1)
      C (Read-line A))

    (If (= C nil) (setq C ""))
     (setq D C)

  (While (/= D "")

    (If (And
     (= (Substr D 1 (Strlen B)) B) (= "," (Substr D (1+ (Strlen B)) 1)))

  (progn
   (setq D "")

    (Les-EN24032 1) (Les-EN24032 2) (Les-EN24032 3) (Les-EN24032 4)
    (Les-EN24032 5) (Les-EN24032 6) (Les-EN24032 7)
    (EN24032_EW)
 );end progn

  (progn
   (setq C (Read-line A))

    (If (= C nil) (setq C ""))
     (setq D C)

    (If (= D "")
      (Princ "\n Eintrag in Datei nicht gefunden.")

    );end if
   );end progn
  );end if
 );end while

);end defun

;************************** Daten umwandeln *******************

(Defun Les-EN24032 (NR)
  (setq D "T")

  (cond 
     ((= NR 2) (setq E "")) ((= NR 3) (setq F "")) ((= NR 4) (setq G ""))
     ((= NR 5) (setq H "")) ((= NR 6) (setq I "")) ((= NR 7) (setq J ""))
  );end cond

  (While (/= D "")
    (setq D (Substr C 1 1))

    (If (Or (= (Ascii D) 44) (= D ""))
     (progn
      (setq D "")

    (if (/= C "")
     (setq C (Substr C 2 (- (Strlen C) 1)))
    );end if

  (cond 
     ((= NR 2) (setq E (Atof E))) ((= NR 3) (setq F (Atof F)))
     ((= NR 4) (setq G (Atof G))) ((= NR 5) (setq H (Atof H)))
     ((= NR 6) (setq I (Atof I))) ((= NR 7) (setq J (Atof J)))
  );end cond
 );end progn

    (progn

  (cond 
     ((= NR 2) (setq E (Strcat E D))) ((= NR 3) (setq F (Strcat F D)))
     ((= NR 4) (setq G (Strcat G D))) ((= NR 5) (setq H (Strcat H D)))
     ((= NR 6) (setq I (Strcat I D))) ((= NR 7) (setq J (Strcat J D)))
  );end cond

(setq C (Substr C 2 (- (Strlen C) 1)))

   );end progn
  );end if
 );end while

);end defun

;***************** Konstruktionspunkte setzen *********************

(defun EN24032_EW ()

(setq aw (* pi 1.5)
      bw (* pi 2)
      cw (/ pi 2)
      dk (- F G)
      em (/ E (sin(* (/ 60.0 180) pi)))
      gwl1 (* pi (/ 190.0 180))
      gwl2 (* pi (/ 260.0 180))
      bohv (- em (sqrt (- (* em em) (* (* (/ em 2) (/ em 2)) 0.30))))
      r (/ E 2)
      rk (/ dk 2.0)
      rb (/ F 2.0))

(24032_KP)

);end defun

;************************* Vorderansicht **************************

(defun 24032_KP()

(setq lmn (getvar "Limmin")
      stp (polar lmn pi 100)
      efp (polar stp cw 100)
      p1 (polar efp bw (* em 0.375))
      p2 (polar p1 cw H)
      p3 (polar efp cw H)
      p4 (polar p3 pi (* em 0.375))
      p5 (polar p4 aw H)
      p6 (polar efp cw bohv)
      p7 (polar p6 bw (/ em 4))
      p8 (polar p7 bw (/ em 4))
      p9 (polar p8 cw (- H (* bohv 2.0)))
      p10 (polar p9 pi (/ em 4))
      p11 (polar p10 pi (/ em 2))
      p12 (polar p11 pi (/ em 4))
      p13 (polar p6 pi (/ em 2))
      p14 (polar p6 pi (/ em 4))
      p15 (polar p3 pi (/ F 2.0))
      p16 (polar p3 pi (/ dk 2.0))
      p17 (polar p3 bw (/ F 2.0))
      p18 (polar p3 bw (/ dk 2.0))
      p19 (polar p15 cw (- (* G 3.0) (/ (- F dk) 2.0)))
      p20 (polar p16 cw (* G 3.0))
      p21 (polar p20 bw dk)
      p22 (polar p19 bw F)
      p23 (polar efp aw 2)                                    ;Mittellinie VA
      p24 (polar p3 cw 2)                                     ;Mittellinie VA
      p25 (polar p3 cw (+ (* G 3.0) 2))                       ;Mittellinie VAG
      p26 (polar efp bw (/ E 2.0))                            ;Punkte fr Seitenansicht
      p27 (polar p26 cw H)
      p28 (polar p27 pi E)
      p29 (polar p28 aw H)
      p30 (polar efp cw bohv)
      p31 (polar p30 bw (/ E 2.0))
      p32 (polar p30 pi (/ E 2.0))
      p33 (polar p27 aw bohv)
      p34 (polar p33 pi (/ E 2.0))
      p35 (polar p33 pi E)
      p36 (polar efp bw (/ E 4.0))
      p37 (polar p36 cw H)
      p38 (polar p37 pi (/ E 2.0))
      p39 (polar p38 aw H)
      p40 (polar efp cw I)                           ;Punkte fr Telleransatz
      p41 (polar efp bw (/ J 2.0))
      p42 (polar p41 cw I)
      p43 (polar p40 bw (/ em 2.0))
      p44 (polar p41 pi J)
      p45 (polar p44 cw I)
      p46 (polar p40 pi (/ em 2.0))
      p47 (polar p40 pi (/ em 4.0))
      p48 (polar p40 bw (/ em 4.0))
      p49 (polar p40 pi (/ E 2.0))
      p50 (polar p40 bw (/ E 2.0))
      p1d (polar efp pi (/ em 2))                      ;Punkte fr Draufsicht
      p2d (polar efp aw (/ E 2.0))
      p3d (polar p2d pi (/ em 4))
      p4d (polar efp pi (+ (/ em 2) 2))
      p5d (polar p4d bw (+ em 4))
      p6d (polar efp aw (+ (/ E 2.0) 2))
      p7d (polar p6d cw (+ E 4))
      p8d (polar efp gwl1 rb)
      p9d (polar efp gwl2 rb)
      p10d (polar efp gwl1 rk)
      p11d (polar efp gwl2 rk))

  (cond 
     ((= VS 1) (VS_AN_4032)) 
     ((= VSG 1) (VSG_AN_4032)) 
     ((= SA 1)  (SA_AN_4032)) 
     ((= SAG 1) (SAG_AN_4032)) 
     ((= DS 1) (DA_AN_4032)) 
     ((= DSG 1) (DAG_AN_4032)) 
  );end cond      

  (altsv)

);end defun

;********************** Vorderansicht ohne Bolzen zeichnen *******************

(defun VS_AN_4032 ()

   (if (= TA 1)
     (progn

(command "Layer" "SE" "SL_TB" ""
         "Linie" p12 p46 p43 p9 "" "Linie" p48 p10 "" "Linie" p47 p11 ""
         "Linie" p2 p4 "" "Linie" p45 p44 p41 p42 ""
         "Bogen" p9 p2 p10 "Bogen" p10 p3 p11 "Bogen" p11 p4 p12)
     );end progn

(command "Layer" "SE" "SL_TB" ""
         "Linie" p8 p9 "" "Linie" p7 p10 "" "Linie" p14 p11 ""
         "Linie" p13 p12 "" "Linie" p5 p1 "" "Linie" p4 p2 ""
         "Bogen" p9 p2 p10 "Bogen" p10 p3 p11 "Bogen" p11 p4 p12
         "Bogen" p13 p5 p14 "Bogen" p14 efp p7 "Bogen" p7 p1 p8)
   );end if

   (if (= ml 1)
      (command "Layer" "SE" "SLM_TB"  ""
               "Linie" p23 p24"")
  );end if

(command "layer" "SE" alay "")
    
    (close A)
   (einfVS_24032)
  (altsv)

);end defun

;******************* Vorderansicht mit Bolzen zeichnen **********************

(defun VSG_AN_4032 ()

   (if (= TA 1)
     (progn

(command "Layer" "SE" "SL_TB" ""
         "Linie" p8 p9 "" "Linie" p48 p10 "" "Linie" p47 p11 ""
         "Linie" p12 p46 p43 p9 "" "Linie" p4 p2 ""
         "Bogen" p9 p2 p10 "Bogen" p10 p3 p11 "Bogen" p11 p4 p12
         "Linie" p15 p19 p20 p21 p22 p17 "" "Linie" p19 p22 ""
         "Linie" p45 p44 p41 p42 "" 
         "Layer" "SE" "SLD_TB" ""
         "Linie" p16 p20 "" "Linie" p18 p21 "")
     );end progn

(command "Layer" "SE" "SL_TB" ""
         "Linie" p8 p9 "" "Linie" p7 p10 "" "Linie" p14 p11 ""
         "Linie" p13 p12 "" "Linie" p5 p1 "" "Linie" p4 p2 ""
         "Bogen" p9 p2 p10 "Bogen" p10 p3 p11 "Bogen" p11 p4 p12
         "Bogen" p13 p5 p14 "Bogen" p14 efp p7 "Bogen" p7 p1 p8
         "Linie" p15 p19 p20 p21 p22 p17 "" "Linie" p19 p22 ""
         "Layer" "SE" "SLD_TB" ""
         "Linie" p16 p20 "" "Linie" p18 p21 "")
   );end if
   
   (if (= ml 1)
      (command "Layer" "SE" "SLM_TB" ""
               "Linie" p23 p25 "")
  );ende if ml
   
(command "layer" "SE" alay "")
    
    (close A)
   (einfVS_G_24032)
  (altsv)

);end defun

;******************* Seitenansicht ohne Bolzen zeichnen *****************

(defun SA_AN_4032 ()

   (if (= TA 1)
     (progn

(command "Layer" "SE" "SL_TB" ""
         "Linie" p50 p27 p28 p49 p50 "" "Linie" p40 p34 ""
         "Linie" p45 p44 p41 p42 "" "Bogen" p33 p37 p34 "Bogen" p34 p38 p35)
    );end progn

(command "Layer" "SE" "SL_TB" ""
         "Linie" p26 p27 p28 p29 p26 "" "Linie" p30 p34 ""
         "Bogen" p30 p36 p31 "Bogen" p33 p37 p34 "Bogen" p34 p38 p35 
         "Bogen" p32 p39 p30)
   );end if

   (if (= ml 1)
      (command "Layer" "SE" "SLM_TB" ""
               "Linie" p23 p24 "")
  );end if
   
(command "layer" "SE" alay "")
     
     (close A)
    (einfVS_24032)
   (altsv)

 );end defun

;**************** Seitenansicht mit Bolzen zeichnen ******************

(defun SAG_AN_4032 ()

   (If (= TA 1)
     (progn
   
(command "Layer" "SE" "SL_TB" ""
         "Linie" p50 p27 p28 p49 p50 "" "Linie" p40 p34 ""
         "Linie" p45 p44 p41 p42 "" "Bogen" p33 p37 p34 "Bogen" p34 p38 p35 
         "Linie" p15 p19 p20 p21 p22 p17 "" "Linie" p19 p22 ""
         "Layer" "SE" "SLD_TB" ""
         "Linie" p16 p20 "" "Linie" p18 p21 "")
     );end progn

(command "Layer" "SE" "SL_TB" ""
         "Linie" p26 p27 p28 p29 p26 "" "Linie" p30 p34 ""
         "Bogen" p30 p36 p31 "Bogen" p33 p37 p34 "Bogen" p34 p38 p35 
         "Bogen" p32 p39 p30 "Linie" p15 p19 p20 p21 p22 p17 "" 
         "Linie" p19 p22 ""
         "Layer" "SE" "SLD_TB" ""
         "Linie" p16 p20 "" "Linie" p18 p21 "")
    );end if
   
   (if (= ml 1)
      (command "Layer" "SE" "SLM_TB" ""
               "Linie" p23 p25 "")
  );end if
   
(command "layer" "SE" alay "")
    
    (close A)
   (einfVS_G_24032)
  (altsv)

);end defun

;*************** Draufsicht ohne Bolzen zeichnen ******************

(defun DA_AN_4032 ()

(command "Layer" "SE" "SL_TB" ""
         "Kreis" efp "d" E "Kreis" efp "d" dk "polygon" 6 "s" p1d p3d
         "Layer" "SE" "SLD_TB" "FA" "2" "" "Lt" "" "SLD_TB" ""
         "Bogen" p9d "z" efp p8d)

  (if (= AKR 1)
     (command "Layer" "SE" "SLM_TB"  ""
              "Linie" p4d p5d "" "Linie" p6d p7d "")
   );end if

(command "layer" "SE" alay "")
   
   (close A)
  (einfDS_24032)
 (altsv)

);end defun

;************* Draufsicht mit Bolzen ohne TA zeichnen ************

(defun DAG_AN_4032 ()

(command "Layer" "SE" "SL_TB" ""
         "Kreis" efp "d" E "Kreis" efp "d" F "Polygon" 6 "s" p1d p3d
         "Layer" "SE" "SLD_TB" ""
         "Bogen" p11d "z" efp p10d)

  (if (= AKR 1)
     (command "Layer" "SE" "SLM_TB" ""
              "Linie" p4d p5d "" "Linie" p6d p7d "")
   );end if
   
(command "layer" "SE" alay "")
   
   (close A)
  (einfDS_24032)
 (altsv)

);end defun

;********* Vorder- und Seitenansicht als Block erstellen *********

(defun einfVS_G_24032 ()

(setvar "Limcheck" 0)

(setq nfile (findfile "znrtbkm.dwg")) 

  (if (= nfile nil)
    (progn

     (if (= ml 1)
       (progn

 (setq elm1 (ssget "X" '((8 . "SL_TB"))))
  (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
   (setq elm3 (ssget "X" '((8 . "SLM_TB"))))
     (sort_4032)
      (command "Wblock" "znrtbkm" "" efp elm1 elm2 elm3 "")
   );end progn
    
 (progn

  (setq elm1 (ssget "X" '((8 . "SL_TB"))))
   (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
     (sort_4032)
      (command "Wblock" "znrtbkm" "" efp elm1 elm2 "")

    );end progn
   );end if 
  );end progn (=nfile nil) 
 );end if (=nfile nil)
 
 (if (/= nfile nil)
   (progn
     
     (if (= ml 1)
       (progn

 (setq elm1 (ssget "X" '((8 . "SL_TB"))))
  (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
    (setq elm3 (ssget "X" '((8 . "SLM_TB"))))
     (sort_4032)
      (command "Wblock" "znrtbkm" "J" "" efp elm1 elm2 elm3 "")
   );end progn
    
 (progn

  (setq elm1 (ssget "X" '((8 . "SL_TB"))))
   (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
     (sort_4032)
      (command "Wblock" "znrtbkm" "J" "" efp elm1 elm2 "")

    );end progn
   );end if
  );end progn (/=nfile nil)
 );end if (/=nfile nil)

(setq elm1 nil elm2 nil elm3 nil)
 (einf_4032) 

  (altsv)

);end defun

;********* Vorder- und Seitenansicht als Block erstellen *********

(defun einfVS_24032 ()

(setvar "Limcheck" 0)

(setq nfile (findfile "znrtbkm.dwg")) 

  (if (= nfile nil)
    (progn

     (if (= ml 1)
       (progn

 (setq elm1 (ssget "X" '((8 . "SL_TB"))))
  (setq elm2 (ssget "X" '((8 . "SLM_TB"))))
     (sort_4032)
      (command "Wblock" "znrtbkm" "" efp elm1 elm2 "")
   );end progn
    
 (progn

  (setq elm1 (ssget "X" '((8 . "SL_TB"))))
     (sort_4032)
      (command "Wblock" "znrtbkm" "" efp elm1 "")

    );end progn
   );end if
  );end progn (=nfile nil) 
 );end if (=nfile nil)
 
 (if (/= nfile nil)
   (progn
     
     (if (= ml 1)
       (progn

 (setq elm1 (ssget "X" '((8 . "SL_TB"))))
  (setq elm2 (ssget "X" '((8 . "SLM_TB"))))
     (sort_4032)
      (command "Wblock" "znrtbkm" "J" "" efp elm1 elm2 "")
   );end progn
    
 (progn

  (setq elm1 (ssget "X" '((8 . "SL_TB"))))
     (sort_4032)
      (command "Wblock" "znrtbkm" "J" "" efp elm1 "")

    );end progn
   );end if
  );end progn (/=nfile nil)
 );end if (/=nfile nil)

(setq elm1 nil elm2 nil)
 (einf_4032) 

  (altsv)

);end defun

;************** Draufsicht Mutter als Block erstellen *************

(defun einfDS_24032 ()

(setvar "Limcheck" 0)

(setq nfile (findfile "znrtbkm.dwg")) 

  (if (= nfile nil)
    (progn

     (if (= AKR 1)
       (progn

 (setq elm1 (ssget "X" '((8 . "SL_TB"))))
  (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
   (setq elm3 (ssget "X" '((8 . "SLM_TB"))))
     (sort_4032)
     (command "Wblock" "znrtbkm" "" efp elm1 elm2 elm3"")
   );end progn
    
 (progn

  (setq elm1 (ssget "X" '((8 . "SL_TB"))))
   (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
     (sort_4032)
     (command "Wblock" "znrtbkm" "" efp elm1 elm2 "")

    );end progn
   ) ;end if
  );end progn (= nfile nil) 
 );end if (= nfile nil)

 (if (/= nfile nil)
   (progn
     
     (if (= AKR 1)
       (progn

 (setq elm1 (ssget "X" '((8 . "SL_TB"))))
  (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
   (setq elm3 (ssget "X" '((8 . "SLM_TB"))))
    (sort_4032)
     (command "Wblock" "znrtbkm" "J" "" efp elm1 elm2 elm3"")
   );end progn
    
 (progn

  (setq elm1 (ssget "X" '((8 . "SL_TB"))))
   (setq elm2 (ssget "X" '((8 . "SLD_TB"))))
     (sort_4032)
     (command "Wblock" "znrtbkm" "J" "" efp elm1 elm2"")

    );end progn
   );end if
  );end progn (/= nfile nil)
 );end if (/= nfile nil)

(setq elm1 nil elm2 nil elm3 nil)
 (einf_4032) 

  (altsv)

);end defun

;******************* Vorhandene Blcke auflisten *****************

(defun sort_4032 (/ Zeichtbkm Zahltbkm)

  (setq Count 0)
   (setq ele_tbkm (tblnext "block" T))
  
  (while (/= nil ele_tbkm)

    (setq Zeichtbkm (substr (cdr (assoc 2 ele_tbkm)) 1 9))
    
  (cond 
     ((= Zeichtbkm "ZNR24032-")
        (setq Zahltbkm (atoi (substr (cdr (assoc 2 ele_tbkm)) 10 3))))
  );end cond
    
        (if (> Zahltbkm Count)
           (setq Count Zahltbkm)
        );end if

    (setq ele_tbkm (tblnext "block" ))
  );ende while
 
);ende defun

;******************** Element als Block einfgen *****************

(defun einf_4032 ()
 
 (setq count  (1+ count))
  (setq counts (itoa count))

   (while (/= (strlen counts) 3)
      (setq counts (strcat "0" counts))
   );end while

 (setq blockef (strcat "ZNR24032-" counts "=znrtbkm"))

 (setvar "cmdecho" 1)

    (command "_insert" blockef pause "" "" pause)
  
  (altsv)

);ende defun

;*********************** Programmende ************************

(prompt "\n EN24032.lsp geladen. Mit Eingabe MU4032 und RETURN starten.")
(princ)
