

(defun c:gxa()       ;(c) RUST 1998
;Letzte nderung: 19.08.98
;Auengewinde-Seitenansicht zeichnen

(setq pnam "GXA.LSP")	;Programmname
(setq pver " V 1.0")	;Programmversion
(setq cpry " (c) Rust 1998 ")	;Copyright

(setq *olderror* *error*)	;Fehlerhandler retten

(defun *error*(msg)	;Fehlerhandler
(res_sysvars)	;restore sysvars
(setq *error* *olderror*)	;restore Fehlerhandler
(princ pnam)
(princ pver)
(princ cpry)
(princ))	;end defun *error*

(defun get_sysvars()	;Systemvariablen merken
(setq o_s (getvar "osmode"))	;Objektfang merken
(setq s_m (getvar "snapmode"))	;Fang merken
(setq a_p (getvar "aperture"))	;Aperture merken
(setq c_e (getvar "cmdecho"))	;Echo merken
(setq b_m (getvar "blipmode"))	;Blips merken
(setq p_w (getvar "plinewid"))	;Polylinienbreite
(setq c_c (getvar "cecolor"))	;Farbe
(setq c_l (getvar "celtype"))	;Linientypfaktor
(setq c_y (getvar "clayer"))	;aktueller layer
)	;end defun get_sysvars

(defun res_sysvars()	;restore sysvars
(command "_layer" "_set" c_y "")	;Layer
(setvar "osmode" o_s)	;Objektfang
(setvar "snapmode" s_m)	;Fang
(setvar "aperture" a_p)	;Aperture 
(setvar "cmdecho" c_e)	;Echo
(setvar "blipmode" b_m)	;Blips
(setvar "plinewid" p_w)	;Polylinienbreite
(setvar "cecolor" c_c)	;Farbe
(setvar "celtype" c_l)	;Linientypfaktor
)	;end defun res_sysvars

(get_sysvars)	;Systemvariablen merken

(setvar "cmdecho" 0)	;Echo aus
(setvar "blipmode" 0)	;keine Blips

(princ "\nAuengewinde Seitenansicht zeichen")

(if (and (/= (type dm) 'REAL) (/= (type dm) 'INT))(setq dm 3.0))

(princ "\nGewinde M <")
(if (= (- dm (fix dm)) 0)(setq dm (fix dm)))

(princ dm)
(setq temp (getreal ">: "))
(if temp (setq dm temp))

(initget 1)
(princ "\nStartpunkt angeben: ")
(setq p1 (getpoint))

(initget 1)
(princ "\nEndpunkt angeben: ")
(setq p2 (getpoint p1))

(setq fi (angle p1 p2))

(setvar "osmode" 0)	;Objektfang aus


;--- Hier Linientyp, Farbe und Layer setzen ---
(command "_linetype" "_s" "continuous" "")
(command "_color" 7)	;weiss
;(command "_layer" "_set" "layername" "")	;Layer setzen

(setq p1a (polar p1 (+ fi (/ pi 2.0)) (* dm 0.5)))
(setq p1e (polar p2 (+ fi (/ pi 2.0)) (* dm 0.5)))

(setq p2a (polar p1 (- fi (/ pi 2.0)) (* dm 0.5)))
(setq p2e (polar p2 (- fi (/ pi 2.0)) (* dm 0.5)))


(command "_line" p1a p1e "")
(command "_line" p2a p2e "")

;--- Hier Farbe und Layer setzen ---
(command "_color" 1)	;rot
;(command "_layer" "_set" "layername" "")	;Layer setzen

(setq p1a (polar p1 (+ fi (/ pi 2.0)) (* dm 0.4)))
(setq p1e (polar p2 (+ fi (/ pi 2.0)) (* dm 0.4)))

(setq p2a (polar p1 (- fi (/ pi 2.0)) (* dm 0.4)))
(setq p2e (polar p2 (- fi (/ pi 2.0)) (* dm 0.4)))

(command "_line" p1a p1e "")
(command "_line" p2a p2e "")

(res_sysvars)	;restore sysvars
(setq *error* *olderror*)	;restore Fehlerhandler
(princ))
(princ "\nGXA geladen")






(defun c:gxb()       ;(c) RUST 1998
;Letzte nderung: 19.08.98
;Auengewinde-Seitenansicht eines Bolzen zeichnen

(setq pnam "GXB.LSP")	;Programmname
(setq pver " V 1.0")	;Programmversion
(setq cpry " (c) Rust 1998 ")	;Copyright

(setq *olderror* *error*)	;Fehlerhandler retten

(defun *error*(msg)	;Fehlerhandler
(res_sysvars)	;restore sysvars
(setq *error* *olderror*)	;restore Fehlerhandler
(princ pnam)
(princ pver)
(princ cpry)
(princ))	;end defun *error*


(defun get_sysvars()	;Systemvariablen merken
(setq o_s (getvar "osmode"))	;Objektfang merken
(setq s_m (getvar "snapmode"))	;Fang merken
(setq a_p (getvar "aperture"))	;Aperture merken
(setq c_e (getvar "cmdecho"))	;Echo merken
(setq b_m (getvar "blipmode"))	;Blips merken
(setq p_w (getvar "plinewid"))	;Polylinienbreite
(setq c_c (getvar "cecolor"))	;Farbe
(setq c_l (getvar "celtype"))	;Linientypfaktor
)	;end defun get_sysvars

(defun res_sysvars()	;restore sysvars
(setvar "osmode" o_s)	;Objektfang
(setvar "snapmode" s_m)	;Fang
(setvar "aperture" a_p)	;Aperture 
(setvar "cmdecho" c_e)	;Echo
(setvar "blipmode" b_m)	;Blips
(setvar "plinewid" p_w)	;Polylinienbreite
(setvar "cecolor" c_c)	;Farbe
(setvar "celtype" c_l)	;Linientypfaktor
)	;end defun res_sysvars

(get_sysvars)	;Systemvariablen merken

(setvar "cmdecho" 0)	;Echo aus
(setvar "blipmode" 0)	;keine Blips

(princ "\nGewindebolzen zeichen") 

(if (and (/= (type dm) 'REAL) (/= (type dm) 'INT))(setq dm 3.0))
(if (= (- dm (fix dm)) 0)(setq dm (fix dm)))

(princ "\nGewinde M <")
(princ dm)
(setq temp (getreal ">: "))
(if temp (setq dm temp))

(initget 1)
(princ "\nBolzen-Startpunkt angeben: ")
(setq p1 (getpoint))

(initget 1)
(princ "\nGewinde-Anfangspunkt angeben: ")
(setq p2 (getpoint p1))

(initget 1)
(princ "\nBolzen-Endpunkt angeben: ")
(setq p3 (getpoint p1))



(setq fi (angle p1 p2))

(setvar "osmode" 0)	;Objektfang aus

;--- Hier Layer, Linientyp und Farbe setzen ---
;(command "_layer" "_set" "layername" "")	;Layer setzen
(command "_linetype" "_s" "continuous" "")
(command "_color" 7)	;weiss



(setq p1a (polar p1 (+ fi (/ pi 2.0)) (* dm 0.5)))
(setq p1b (polar p1 (- fi (/ pi 2.0)) (* dm 0.5)))

(setq p2a (polar p2 (+ fi (/ pi 2.0)) (* dm 0.5)))
(setq p2b (polar p2 (- fi (/ pi 2.0)) (* dm 0.5)))

(setq p2ar (polar p2 (+ fi (/ pi 2.0)) (* dm 0.4)))
(setq p2br (polar p2 (- fi (/ pi 2.0)) (* dm 0.4)))

(setq p3v (polar p3 (- fi pi) (* dm 0.1)))

(setq p3va (polar p3v (+ fi (/ pi 2.0)) (* dm 0.5)))
(setq p3vb (polar p3v (- fi (/ pi 2.0)) (* dm 0.5)))


(setq p3a (polar p3 (+ fi (/ pi 2.0)) (* dm 0.4)))
(setq p3b (polar p3 (- fi (/ pi 2.0)) (* dm 0.4)))


(command "_line" p1a p3va "")
(command "_line" p1b p3vb "")
(command "_line" p3va p3vb "")
(command "_line" p3a p3b "")
(command "_line" p3a p3va "")
(command "_line" p3b p3vb "")
(command "_line" p2a p2b "")


;--- Hier Layer und Farbe setzen ---
;(command "_layer" "_set" "layername" "")	;Layer setzen
(command "_color" 1)	;rot

(command "_line" p2ar p3a "")
(command "_line" p2br p3b "")

(res_sysvars)	;restore sysvars
(setq *error* *olderror*)	;restore Fehlerhandler
(princ))
(princ "\nGXB geladen")



(defun c:gxi()       ;(c) RUST 1998
;Letzte nderung: 19.08.98
;Innengewinde-Seitenansicht zeichnen

(setq pnam "GXI.LSP")	;Programmname
(setq pver " V 1.0")	;Programmversion
(setq cpry " (c) Rust 1998 ")	;Copyright

(setq *olderror* *error*)	;Fehlerhandler retten

(defun *error*(msg)	;Fehlerhandler
(res_sysvars)	;restore sysvars
(setq *error* *olderror*)	;restore Fehlerhandler
(princ pnam)
(princ pver)
(princ cpry)
(princ))	;end defun *error*

(defun get_sysvars()	;Systemvariablen merken
(setq o_s (getvar "osmode"))	;Objektfang merken
(setq s_m (getvar "snapmode"))	;Fang merken
(setq a_p (getvar "aperture"))	;Aperture merken
(setq c_e (getvar "cmdecho"))	;Echo merken
(setq b_m (getvar "blipmode"))	;Blips merken
(setq p_w (getvar "plinewid"))	;Polylinienbreite
(setq c_c (getvar "cecolor"))	;Farbe
(setq c_l (getvar "celtype"))	;Linientypfaktor
)	;end defun get_sysvars

(defun res_sysvars()	;restore sysvars
(setvar "osmode" o_s)	;Objektfang
(setvar "snapmode" s_m)	;Fang
(setvar "aperture" a_p)	;Aperture 
(setvar "cmdecho" c_e)	;Echo
(setvar "blipmode" b_m)	;Blips
(setvar "plinewid" p_w)	;Polylinienbreite
(setvar "cecolor" c_c)	;Farbe
(setvar "celtype" c_l)	;Linientypfaktor
)	;end defun res_sysvars

(get_sysvars)	;Systemvariablen merken

(setvar "cmdecho" 0)	;Echo aus
(setvar "blipmode" 0)	;keine Blips


(if (and (/= (type dm) 'REAL) (/= (type dm) 'INT))(setq dm 3.0))
(if (= (- dm (fix dm)) 0)(setq dm (fix dm)))

(princ "\nInnengewinde Seitenansicht zeichen")


(princ "\nGewinde M <")
(princ dm)
(setq temp (getreal ">: "))
(if temp (setq dm temp))

(initget 1)
(princ "\nStartpunkt angeben: ")
(setq p1 (getpoint))

(initget 1)
(princ "\nEndpunkt angeben: ")
(setq p2 (getpoint p1))

(setq fi (angle p1 p2))

(setvar "osmode" 0)	;Objektfang aus


;--- Hier Layer, Linientyp und Farbe setzen ---
;(command "_layer" "_set" "layername" "")	;Layer setzen
(command "_linetype" "_s" "continuous" "")
(command "_color" 1)	;weiss

(setq p1a (polar p1 (+ fi (/ pi 2.0)) (* dm 0.5)))
(setq p1e (polar p2 (+ fi (/ pi 2.0)) (* dm 0.5)))

(setq p2a (polar p1 (- fi (/ pi 2.0)) (* dm 0.5)))
(setq p2e (polar p2 (- fi (/ pi 2.0)) (* dm 0.5)))


(command "_line" p1a p1e "")
(command "_line" p2a p2e "")


;--- Hier Layer und Farbe setzen ---
;(command "_layer" "_set" "layername" "")	;Layer setzen
(command "_color" 7)	;weiss

(setq p1a (polar p1 (+ fi (/ pi 2.0)) (* dm 0.4)))
(setq p1e (polar p2 (+ fi (/ pi 2.0)) (* dm 0.4)))

(setq p2a (polar p1 (- fi (/ pi 2.0)) (* dm 0.4)))
(setq p2e (polar p2 (- fi (/ pi 2.0)) (* dm 0.4)))

(command "_line" p1a p1e "")
(command "_line" p2a p2e "")

(res_sysvars)	;restore sysvars
(setq *error* *olderror*)	;restore Fehlerhandler
(princ))
(princ "\nGXI geladen")








(defun c:gxs()       ;(c) RUST 1998
;Letzte nderung: 07.08.98
;Innengewinde+Sackloch-Seitenansicht im Schnitt zeichnen

(setq pnam "GXS.LSP")	;Programmname
(setq pver " V 1.0")	;Programmversion
(setq cpry " (c) Rust 1998 ")	;Copyright

(setq *olderror* *error*)	;Fehlerhandler retten

(defun *error*(msg)	;Fehlerhandler
(res_sysvars)	;restore sysvars
(setq *error* *olderror*)	;restore Fehlerhandler
(princ pnam)
(princ pver)
(princ cpry)
(princ))	;end defun *error*

(defun get_sysvars()	;Systemvariablen merken
(setq o_s (getvar "osmode"))	;Objektfang merken
(setq s_m (getvar "snapmode"))	;Fang merken
(setq a_p (getvar "aperture"))	;Aperture merken
(setq c_e (getvar "cmdecho"))	;Echo merken
(setq b_m (getvar "blipmode"))	;Blips merken
(setq p_w (getvar "plinewid"))	;Polylinienbreite
(setq c_c (getvar "cecolor"))	;Farbe
(setq c_l (getvar "celtype"))	;Linientypfaktor
(setq c_y (getvar "clayer"))	;aktueller layer
)	;end defun get_sysvars

(defun res_sysvars()	;restore sysvars
(command "_layer" "_set" c_y "")	;Layer
(setvar "osmode" o_s)	;Objektfang
(setvar "snapmode" s_m)	;Fang
(setvar "aperture" a_p)	;Aperture 
(setvar "cmdecho" c_e)	;Echo
(setvar "blipmode" b_m)	;Blips
(setvar "plinewid" p_w)	;Polylinienbreite
(setvar "cecolor" c_c)	;Farbe
(setvar "celtype" c_l)	;Linientypfaktor
)	;end defun res_sysvars

(get_sysvars)	;Systemvariablen merken

(setvar "cmdecho" 0)	;Echo aus
(setvar "blipmode" 0)	;keine Blips

(if (and (/= (type dm) 'REAL) (/= (type dm) 'INT))(setq dm 3.0))
(if (= (- dm (fix dm)) 0)(setq dm (fix dm)))

(princ "\nSackloch-Innengewinde zeichen")

(princ "\nGewinde M <")
(princ dm)
(setq temp (getreal ">: "))
(if temp (setq dm temp))

(initget 1)
(princ "\nGewinde-Startpunkt angeben: ")
(setq p1 (getpoint))

(initget 1)
(princ "\nGewinde-Endpunkt angeben: ")
(setq p2 (getpoint p1))


(initget 1)
(princ "\nSackloch-Endpunkt angeben: ")
(setq p3 (getpoint p2))


(setq fi (angle p1 p2))

(setvar "osmode" 0)	;Objektfang aus

;--- Hier Layer, Linientyp und Farbe setzen ---
;(command "_layer" "_set" "layername" "")	;Layer setzen
(command "_linetype" "_s" "continuous" "")
(command "_color" 1)	;Farbe setzen 1=rot

(setq p1a (polar p1 (+ fi (/ pi 2.0)) (* dm 0.5)))
(setq p1e (polar p2 (+ fi (/ pi 2.0)) (* dm 0.5)))

(setq p2a (polar p1 (- fi (/ pi 2.0)) (* dm 0.5)))
(setq p2e (polar p2 (- fi (/ pi 2.0)) (* dm 0.5)))


(command "_line" p1a p1e "")
(command "_line" p2a p2e "")

;--- Hier Layer und Farbe setzen ---
;(command "_layer" "_set" "layername" "")	;Layer setzen
(command "_color" 7)	;weiss

(command "_line" p1e p2e "")

(setq p1a (polar p1 (+ fi (/ pi 2.0)) (* dm 0.4)))
(setq p1e (polar p2 (+ fi (/ pi 2.0)) (* dm 0.4)))

(setq p2a (polar p1 (- fi (/ pi 2.0)) (* dm 0.4)))
(setq p2e (polar p2 (- fi (/ pi 2.0)) (* dm 0.4)))

(command "_line" p1a p1e "")
(command "_line" p2a p2e "")


(setq p3e (polar p3 (+ fi (/ pi 2.0)) (* dm 0.4)))
(setq p4e (polar p3 (- fi (/ pi 2.0)) (* dm 0.4)))

(command "_line" p1e p3e "")
(command "_line" p2e p4e "")
(command "_line" p3e p4e "")

(setq fi (angle p3e p4e))
(setq p5 (polar p3e (+ (/ pi 6)(- fi (/ 0 3))) (/ (* 0.4 dm) (cos (/ pi 6)))))

(command "_line" p3e p5 p4e "")

(res_sysvars)	;restore sysvars
(setq *error* *olderror*)	;restore Fehlerhandler
(princ))
(princ "\nGXS geladen")







(defun c:gza()       ;(c) RUST 1998
;Letzte nderung: 19.08.98
;Auengewinde-Draufsicht zeichnen

(setq pnam "GZA.LSP")	;Programmname
(setq pver " V 1.0")	;Programmversion
(setq cpry " (c) Rust 1998 ")	;Copyright

(setq *olderror* *error*)	;Fehlerhandler retten

(defun *error*(msg)	;Fehlerhandler
(res_sysvars)	;restore sysvars
(setq *error* *olderror*)	;restore Fehlerhandler
(princ pnam)
(princ pver)
(princ cpry)
(princ))	;end defun *error*

(defun get_sysvars()	;Systemvariablen merken
(setq o_s (getvar "osmode"))	;Objektfang merken
(setq s_m (getvar "snapmode"))	;Fang merken
(setq a_p (getvar "aperture"))	;Aperture merken
(setq c_e (getvar "cmdecho"))	;Echo merken
(setq b_m (getvar "blipmode"))	;Blips merken
(setq p_w (getvar "plinewid"))	;Polylinienbreite
(setq c_c (getvar "cecolor"))	;Farbe
(setq c_l (getvar "celtype"))	;Linientypfaktor
)	;end defun get_sysvars

(defun res_sysvars()	;restore sysvars
(setvar "osmode" o_s)	;Objektfang
(setvar "snapmode" s_m)	;Fang
(setvar "aperture" a_p)	;Aperture 
(setvar "cmdecho" c_e)	;Echo
(setvar "blipmode" b_m)	;Blips
(setvar "plinewid" p_w)	;Polylinienbreite
(setvar "cecolor" c_c)	;Farbe
(setvar "celtype" c_l)	;Linientypfaktor
)	;end defun res_sysvars

(get_sysvars)	;Systemvariablen merken

(setvar "cmdecho" 0)	;Echo aus
(setvar "blipmode" 0)	;keine Blips



(if (and (/= (type dm) 'REAL) (/= (type dm) 'INT))(setq dm 3.0))
(if (= (- dm (fix dm)) 0)(setq dm (fix dm)))

(princ "\nAuengewinde Draufsicht zeichen")

(princ "\nGewinde M <")
(princ dm)
(setq temp (getreal ">: "))
(if temp (setq dm temp))

(initget 1)
(princ "\nEinfgepunkt angeben: ")
(setq p1 (getpoint))

(setvar "osmode" 0)	;Objektfang aus

;--- Hier Layer, Linientyp und Farbe setzen ---
;(command "_layer" "_set" "layername" "")	;Layer setzen
(command "_linetype" "_s" "continuous" "")
(command "_color" 7)	;weiss

(command "_circle" p1 "d" dm)



;--- Hier Layer und Farbe setzen ---
;(command "_layer" "_set" "layername" "")	;Layer setzen
(command "_color" 1)	;rot

(setq di (* 0.8 dm))

(setq pe (polar p1 (+ (/ pi 2.0) (/ pi 8.0)) (/ di 2.0)))
(setq ps (polar p1 (+         pi (/ pi 8.0)) (/ di 2.0)))

(command "_arc" "m" p1 ps pe)

(res_sysvars)	;restore sysvars
(setq *error* *olderror*)	;restore Fehlerhandler
(princ))
(princ "\nGZA geladen")







(defun c:gzi()       ;(c) RUST 1998
;Letzte nderung: 19.03.89
;Innengewinde-Draufsicht zeichnen

(setq pnam "GZI.LSP")	;Programmname
(setq pver " V 1.0")	;Programmversion
(setq cpry " (c) Rust 1998 ")	;Copyright

(setq *olderror* *error*)	;Fehlerhandler retten

(defun *error*(msg)	;Fehlerhandler
(res_sysvars)	;restore sysvars
(setq *error* *olderror*)	;restore Fehlerhandler
(princ pnam)
(princ pver)
(princ cpry)
(princ))	;end defun *error*

(defun get_sysvars()	;Systemvariablen merken
(setq o_s (getvar "osmode"))	;Objektfang merken
(setq s_m (getvar "snapmode"))	;Fang merken
(setq a_p (getvar "aperture"))	;Aperture merken
(setq c_e (getvar "cmdecho"))	;Echo merken
(setq b_m (getvar "blipmode"))	;Blips merken
(setq p_w (getvar "plinewid"))	;Polylinienbreite
(setq c_c (getvar "cecolor"))	;Farbe
(setq c_l (getvar "celtype"))	;Linientypfaktor
)	;end defun get_sysvars

(defun res_sysvars()	;restore sysvars
(setvar "osmode" o_s)	;Objektfang
(setvar "snapmode" s_m)	;Fang
(setvar "aperture" a_p)	;Aperture 
(setvar "cmdecho" c_e)	;Echo
(setvar "blipmode" b_m)	;Blips
(setvar "plinewid" p_w)	;Polylinienbreite
(setvar "cecolor" c_c)	;Farbe
(setvar "celtype" c_l)	;Linientypfaktor
)	;end defun res_sysvars

(get_sysvars)	;Systemvariablen merken

(setvar "cmdecho" 0)	;Echo aus
(setvar "blipmode" 0)	;keine Blips


(if (and (/= (type dm) 'REAL) (/= (type dm) 'INT))(setq dm 3.0))
(if (= (- dm (fix dm)) 0)(setq dm (fix dm)))

(princ "\nInnengewinde Draufsicht zeichen")

(princ "\nGewinde M <")
(princ dm)
(setq temp (getreal ">: "))
(if temp (setq dm temp))

(initget 1)
(princ "\nEinfgepunkt angeben: ")
(setq p1 (getpoint))

(setvar "osmode" 0)	;Objektfang aus

(setq di (* 0.8 dm))


;--- Hier Layer, Linientyp und Farbe setzen ---
;(command "_layer" "_set" "layername" "")	;Layer setzen
(command "_linetype" "_s" "continuous" "")
(command "_color" 7)	;weiss


(command "_circle" p1 "d" di)


;--- Hier Layer und Farbe setzen ---
;(command "_layer" "_set" "layername" "")	;Layer setzen
(command "_color" 1)	;rot


(setq pe (polar p1 (+ (/ pi 2.0) (/ pi 8.0)) (/ dm 2.0)))
(setq ps (polar p1 (+         pi (/ pi 8.0)) (/ dm 2.0)))


(command "_arc" "m" p1 ps pe)

(res_sysvars)	;restore sysvars
(setq *error* *olderror*)	;restore Fehlerhandler
(princ))
(princ "\nGZI geladen")
(princ)








