;  Programm: "gl_ingew.lsp" zeichnet Grundlochwinde in der gewnschten
;            Lage in Vorderansicht und Draufsicht sichtbar oder verdeckt.
;
;  Erforderliche Zusatzdatei: grl_gew.ldt
;                             grl_gew.dcl
;                             grl_gew.slb
;
;  Programmiert von: Karl Maurer   (C) 1998
;
;  Einsatzbereich: AutoCAD 12, 13 und 14 unter DOS/Windows/NT
;
;  Anmerkung: Vom Programm werden die Layer "SL_TBF", "SLM_TBF" "SLV_TBF" 
;             und "SLD" erzeugt und die einzelnen Zeichnungselemente auf 
;             diese Layer gezeichnet.
;
;             Gewindelinien auf "SLD_TBG"
;             Mittellinien auf "SLM_TBG"
;             Verdeckte Linien "SLV_TBG"
;             Alle anderen Linien auf "SL_TBG".
;
;  Alle vorher eingestellten Systemvariablen die durch dieses Programm
;  verndert wurden, werden wieder zurckgesetzt.
;
;********************* Programmbeginn *********************

(prompt "\n Bitte warten..... Ingew.lsp geladen.")

(Defun C:G_INGW (/ A B C D E F dk dm a1 aw bw cw lg efp p1 p2 p3 p4 p5 p6 p7 
                 p8 p9 p10 p11 p12 p13 p14 p15 p16 wi_li wi_re ncd ML AKR 
                 GGV GGS DS DV bo_tiefe bo_sp dcl slb dcl_gingew vz dcl)


(setq cm (getvar "cmdecho"))
(setq bl (getvar "blipmode"))
(setq os (getvar "osmode"))
(setq alay (getvar "clayer"))

(setvar "cmdecho" 0)
(setvar "blipmode" 0)
(setvar "osmode" 0)
(tb_layer)
)

(defun altsv ()
(setvar "blipmode" bl)
(setvar "osmode" os)
(setvar "cmdecho" cm)
)

(defun *error* (emsg)
(princ emsg)
(altsv)
(princ)
)

;************************** Layer erzeugen *************************

(defun tb_layer ()

(command "Layer" "M" "SL_TBF" "FA" "7" "" "LT" "" "SL_TBF" ""
         "Layer" "M" "SLM_TBF" "FA" "2" "" "LT" "Mitte" "SLM_TBF" ""
         "Layer" "M" "SLD_TBF" "FA" "2" "" "LT" "" "SLD_TBF" ""
         "Layer" "M" "SLV_TBF" "FA" "1" "" "LT" "Verdeckt" "SLV_TBF" "")

(command "layer" "SE" alay "")

  (Start_gl_ingew)

);end defun

;********************** Zusatzdatei ffnen *********************

(defun Start_gl_ingew ()

(setq ncd (findfile "grl_gew.ldt"))
    
    (If (= Nil ncd)
      (progn
      (princ "Datei grl_gew.ldt kann nicht geffnet werden!")
       (setq vz (getstring t "\n Verzeichnis der Zusatzdatei eingeben: "))
        (setq A (Open (strcat "/" vz "/" "grl_gew.ldt") "r"))
     );end progn
   );end if

     (if ncd (setq A (Open ncd "r")) )
 
 (gl_ingew_dcl)

);end defun

;************************ DCL-Datei starten ************************

(defun gl_ingew_dcl ()

(setq dcl (findfile "grl_gew.dcl"))
 (setq slb (findfile "grl_gew.slb"))
  (setq dcl_gingew (load_dialog "grl_gew.dcl")) 
   (if (not (new_dialog "grl_gew" dcl_gingew)) (exit))
    (setq hilf (findfile "grl_gew.hil"))

(setq DM_gingw (list " M3" " M4" " M5" " M6" " M8" " M10" " M12" " (M14)" 
                     " M16" " (M18)" " M20" " (M22)" " M24" " (M27)" " M30" 
                     " (M33)" " M36" " (M39)" " M42" " (M45)" " M48" " (M52)" 
                     " M56" " (M60)" " M64"))


(setq Bre (dimx_tile "GGW_S"))
(setq Hoe (dimy_tile "GGW_S" ))
(start_image "GGW_S")
(slide_image 0 0 bre hoe "grl_gew(g_gew_vs)")
(end_image)

(setq Bre (dimx_tile "GGW_V"))
(setq Hoe (dimy_tile "GGW_V"))
(start_image "GGW_V")
(slide_image 0 0 bre hoe "grl_gew(g_gew_VV)")
(end_image)

(setq Bre (dimx_tile "DS_S"))
(setq Hoe (dimy_tile "DS_S"))
(start_image "DS_S")
(slide_image 0 0 bre hoe "grl_gew(i_gew_ds)")
(end_image)

(setq Bre (dimx_tile "DS_V"))
(setq Hoe (dimy_tile "DS_V"))
(start_image "DS_V")
(slide_image 0 0 bre hoe "grl_gew(i_gew_dv)")
(end_image)

(action_tile "GGW_S" "(setq GGS (atoi $value) GGV 0 DGS 0 DS 0 DV 0) 
                      (mod_gingew) (dm_list) ")
(action_tile "GGW_V" "(setq GGV (atoi $value) GGS 0 DS 0 DV 0) 
                      (mod_gingew) (dm_list) ")
(action_tile "DS_S" "(setq DS (atoi $value) GGV 0 GGS 0 DV 0) 
                     (mod_gingew) (dm_list) ")
(action_tile "DS_V" "(setq DV (atoi $value) GGV 0 GGS 0 DS 0) 
                     (mod_gingew) (dm_list) ")
(action_tile "DM" "(setq DM (atoi $value)) (DM_gingew) ")
(action_tile "ML" "(setq ML (atoi $value))")
(action_tile "AKR" "(setq AKR (atoi $value))")
(action_tile "hilfe" "(setq hilfe (atoi $value)) (hil)")
(action_tile "accept" "(if (/= DM nil) (done_dialog 1))")

(setq OK (start_dialog))

     (if (= OK 1) (dat_gingew))

(action_tile "cancel" "(done_dialog)")
  (unload_dialog dcl_gingew)

(princ)
);end defun

;************************ Hilfedatei anzeigen ****************

(defun hil ()

(if (= hilfe 1)
    (startapp "notepad" hilf))

);end defun

;******************** Durchmesserlisten anzeigen *****************

(defun dm_list ()

   (cond
      ((or (= GGS 1) (= GGV 1)(= DS 1) (= DV 1))
      (start_list "DM") (mapcar 'add_list DM_gingw) (end_list))
   );end cond

);end defun

;******************* Einstellungen ndern ************************

(defun mod_gingew ()

   (cond
      ((= GGS 1) (mode_tile "ML" 0) (mode_tile "AKR" 1))
      ((= GGV 1) (mode_tile "ML" 0) (mode_tile "AKR" 1))
      ((= DS 1)  (mode_tile "ML" 1) (mode_tile "AKR" 0))
      ((= DV 1)  (mode_tile "ML" 1) (mode_tile "AKR" 0))
   );end cond
 
);end defun

;********************** Durchmesser bestimmen ********************

(defun DM_gingew ()

  (cond
     ((= dm 0) (setq dm 3)) ((= dm 1) (setq dm 4)) ((= dm 2) (setq dm 5))
     ((= dm 3) (setq dm 6)) ((= dm 4) (setq dm 8)) ((= dm 5) (setq dm 10))
     ((= dm 6) (setq dm 12)) ((= dm 7) (setq dm 14)) ((= dm 8) (setq dm 16)) 
     ((= dm 9) (setq dm 18)) ((= dm 10) (setq dm 20)) ((= dm 11) (setq dm 22)) 
     ((= dm 12) (setq dm 24)) ((= dm 13) (setq dm 27)) ((= dm 14) (setq dm 30))
     ((= dm 15) (setq dm 33)) ((= dm 16) (setq dm 36)) ((= dm 17) (setq dm 39)) 
     ((= dm 18) (setq dm 42)) ((= dm 19) (setq dm 45)) ((= dm 20) (setq dm 48)) 
     ((= dm 21) (setq dm 52)) ((= dm 22) (setq dm 56)) ((= dm 23) (setq dm 60)) 
     ((= dm 24) (setq dm 64))  
   );end cond

);ende defun

;************************ Daten einlesen **********************

(defun dat_gingew ()

(setq a1 (itoa dm)
      B (strcat "M" a1)
      C (Read-line A))
   
    (If (= C nil) (setq C ""))
     (setq D C)
   
   (While (/= D "")
    
    (If (And (= (Substr D 1 (Strlen B)) B) (= "," (Substr D (1+ (Strlen B)) 1)) )
      (progn 
       (setq D "")

        (Les-gingew 1) (Les-gingew 2) (Les-gingew 3) (Les-gingew 4)

   (cond
      ((or (= GGS 1) (= GGV 1))(KW_ingew))
      ((or (= DS 1) (= DV 1)) (DS_ingew))
    );end cond
   );end progn
    
    (progn

     (setq C (Read-line A))
    
    (If (= C nil) (setq C ""))
     (setq D C)
    
   );end progn
  );end if
 );end while

);end defun

;*********************** Daten umwandeln **********************

(Defun Les-gingew (NR)

  (setq D "T")

  (cond 
     ((= NR 2) (setq E "")) ((= NR 3) (setq F "")) ((= NR 4) (setq G ""))
  );end cond
   
   (While (/= D "")
    (setq D (Substr C 1 1))
   
    (If (Or (= D ",") (= D ""))
     (progn
      (setq D "")
    
    (if (/= C "")
     (setq C (Substr C 2 (- (Strlen C) 1)))
   );end if

  (cond 
     ((= NR 2) (setq E (Atof E))) ((= NR 3) (setq F (Atof F))) 
     ((= NR 4) (setq G (Atof G)))
   );end cond
 );end progn
   
   (progn

  (cond 
     ((= NR 2) (setq E (Strcat E D))) ((= NR 3) (setq F (Strcat F D))) 
     ((= NR 4) (setq G (Strcat G D)))
  );end cond

    (setq C (Substr C 2 (- (Strlen C) 1)))

   );end progn
  );end if
 );end while

);end defun

;***************** Konstruktionspunkte setzen **********************

(Defun KW_ingew ()
  
(setq dk (- E F) )
   
   (if (<= (- E dk) 0.6)
     (setq dk (- E 0.6))
  );end if

(setq efp (getpoint "\n Einfgepunkt:"))
 (setq lg (getpoint efp "\n Gewindelnge (zeigen oder eingeben):"))
  (setq lg (distance efp lg))
   (setq wi (getorient efp "\n Einfgerichtung zeigen oder Winkel eingeben"))

(setq bo_tiefe (+ lg G)
      bo_sp (+ bo_tiefe (* 0.3 dk))
      p1 (polar efp (- wi (/ pi 2.0)) (/ dk 2))   
      p2 (polar efp (- wi (/ pi 2.0)) (/ E 2.0))
      p3 (polar efp (+ wi (/ pi 2.0)) (/ dk 2))   
      p4 (polar efp (+ wi (/ pi 2.0)) (/ E 2.0))
      p5 (polar p1 wi bo_tiefe)   
      p6 (polar p2 wi lg)
      p7 (polar p3 wi bo_tiefe)
      p8 (polar p4 wi lg)
      p9 (polar efp wi bo_sp)
      p10 (polar efp (+ wi pi) 2)
      p11 (polar p9 wi 2) )

  (cond
     ((= GGS 1) (ZE_ggs))
     ((= GGV 1) (ZE_ggv))
  );end cond

);end defun

;*********** Grundlochgewinde sichtbar zeichnen *************

(defun ZE_ggs ()

(command "Layer" "SE" "SL_TBF" ""
         "Linie" p1 p5 p9 p7 p3 "" "Linie" p5 p7 "" "Linie" p6 p8 ""
         "Layer" "SE" "SLD_TBF" ""
         "Linie" p2 p6 "" "Linie" p4 p8 "")
       
   (if (= ML 1)
      (command "Layer" "SE" "SLM_TBF" ""
               "Linie" p10 p11 "")
  );end if

 (command "Layer" "SE" alay "")

  (close A)
 (altsv)

);end defun

;*********** Grundlochgewinde verdeckt zeichnen *************

(defun ZE_ggv ()

(command "Layer" "SE" "SLV_TBF" ""
         "Linie" p1 p5 p9 p7 p3 "" "Linie" p2 p6 p8 p4 "" "Linie" p5 p7 "")
       
   (if (= ML 1)
      (command "Layer" "SE" "SLM_TBF" ""
               "Linie" p10 p11 "")
  );end if

 (command "Layer" "SE" alay "")

  (close A)
 (altsv)

);end defun

;************** Konstruktionspunkte Draufsicht *************

(defun DS_ingew ()

(setq aw (* pi 1.5)  
      bw (* pi 2)  
      cw (/ pi 2)
      dk (- E F)
      wi_li (* pi (/ 190.0 180))
      wi_re (* pi (/ 260.0 180)) )
   
   (if (<= (- E dk) 0.6)
     (setq dk (- E 0.6))
  );end if

(setq efp (getpoint "\n Einfgepunkt")
      p11 (polar efp wi_li (/ E 2.0))
      p12 (polar efp wi_re (/ E 2.0)) 
      p13 (polar efp pi (+ (/ E 2.0) 2))
      p14 (polar efp bw (+ (/ E 2.0) 2))
      p15 (polar efp cw (+ (/ E 2.0) 2))
      p16 (polar efp aw (+ (/ E 2.0) 2)) )

   (cond
      ((= DS 1) (ZE_ds))
      ((= DV 1) (ZE_dv))
   );end cond

);end defun

;**************** Draufsicht sichtbar zeichnen *****************

(defun ZE_ds ()

(command "Layer" "SE" "SL_TBF" ""
         "Kreis" efp "D" dk 
         "Layer" "SE" "SLD_TBF" ""
         "Bogen" p12 "z" efp p11) 
    
   (if (= AKR 1)
      (command "Layer" "SE" "SLM_TBF" ""
               "Linie" p13 p14 "" "Linie" p15 p16 "")
   );end if

(command "Layer" "SE" alay "")

  (close A)
 (altsv)

);end defun

;**************** Draufsicht verdeckt zeichnen *****************

(defun ZE_dv ()

(command "Layer" "SE" "SLV_TBF" ""
         "Kreis" efp "D" dk "Bogen" p12 "z" efp p11) 
    
   (if (= AKR 1)
      (command "Layer" "SE" "SLM_TBF" ""
               "Linie" p13 p14 "" "Linie" p15 p16 "")
   );end if

(command "Layer" "SE" alay "")

  (close A)
 (altsv)

);end defun

;********************* Programmende ************************

(prompt "\n gl_ingew.lsp geladen. Mit Eingabe G_INGW und RETURN starten")
(princ)
