;;;***********************************
;;;***********************************
;;;
;;;	POSNR
;;; 	Routine zum Erzeugen von Positionsnummern
;;;
;;;	Programmiert von
;;;
;;;	CAD-Technik Nelkel
;;;	Wilfried Nelkel
;;;	In der Langen Nacht 18
;;;	92289 Hohenkemnath
;;;	Tel. 09628/914144
;;;	Fax. 09628/914145
;;;	eMail: autocad@cad-nelkel.de
;;;	Web:   http://www.cad-nelkel.de
;;;
;;;***********************************
;;;***********************************
;;;
;;;
;;; Lauffhig unter AutoCAD 2000 / 2002


(DEFUN C:POSNR (/ R1 R2 PKT)
  (SETQ	DCL_ID	 (LOAD_DIALOG "Posnr.DCL")
	aFARBE	 (GETVAR "cecolor")
	A_CMD	 (GETVAR "cmdecho")
	A_LAY	 (GETVAR "clayer")
	TEXTHHE 3
  )

  (IF (NULL (NEW_DIALOG "posnr" DCL_ID))
    (ALERT
      "\nKann die Dialogboxdatei POSNR.DCL \n nicht finden / laden !"
    )
  )
  (SETVAR "cmdecho" 0)
  (DIA_ZEIG)
  (FARBZEIG)
  (POS_LAY_EINL)
  (START_LIST "laylist")
  (MAPCAR 'ADD_LIST LAY_LIS)
  (END_LIST)
  (IF (NULL POSNR)
    (SETQ POSNR 1)
  )
  (IF TEXTHHE
    (SET_TILE "th" (RTOS TEXTHHE 2 3))
  )
  (IF POSNR
    (SET_TILE "stnr" (ITOA POSNR))
  )
  (IF FARBE
    (SET_TILE "farbe" FARBE)
  )
  (IF (NULL TYP)
    (SETQ TYP 1)
  )
  (COND
    ((= TYP 0) (SET_TILE "kreis" "1"))
    ((= TYP 1) (SET_TILE "qudr" "1"))
    ((= TYP 2) (SET_TILE "unter" "1"))
    ((= TYP 3) (SET_TILE "raute" "1"))
    ((= TYP 4) (SET_TILE "kein" "1"))
  )
  (ACTION_TILE "laylist" "(take-layer)")
  (ACTION_TILE "color" "(DONE_DIALOG 2)")
  (ACTION_TILE "th" "(setq texthhe (atof $value))")
  (ACTION_TILE "stnr" "(setq posnr (atoi $value))")
  (ACTION_TILE "kreis" "(setq typ 0)")
  (ACTION_TILE "qudr" "(setq typ 1)")
  (ACTION_TILE "unter" "(setq typ 2)")
  (ACTION_TILE "raute" "(setq typ 3)")
  (ACTION_TILE "kein" "(setq typ 4)")
  (ACTION_TILE "winklist" "(SETQ G (ATOI (NTH (ATOI $VALUE) winklist)))")
  (ACTION_TILE "seg" "(SETQ seg (ATOI (NTH (ATOI $VALUE) seglist)))")
  (ACTION_TILE "cancel" "(DONE_DIALOG 0)")
  (ACTION_TILE "accept" "(done_dialog 1)")
  (SETQ ETSTAT (START_DIALOG))
  (COND
    ((= ETSTAT 0) (UNLOAD_DIALOG DCL_ID))
    ((= ETSTAT 1) (POSNR_Z))
    ((= ETSTAT 2) (UNLOAD_DIALOG DCL_ID) (DDCOLORSTART))
  )
  (PRINC)
)

(DEFUN POSNR_Z ()
  (IF (OR (NULL POSNR) (NULL TEXTHHE))
    (PROGN
      (ALERT "\nAchtung, fehlende Werte in einem Feld !")
      (C:POSNR)
    )
    (POS_NR_MACH)
  )
  (VARREST)
)


(DEFUN POS_NR_MACH ()
  (SETQ	DIGITS	TEXTHHE
	ALT_COL	(GETVAR "cecolor")
  )
  (IF (NULL POSNR)
    (SETQ POSNR 1)
  )
  (SETVAR "cecolor" FARBE)
  (SETQ PKT (GETPOINT "\nPunkt fr Pos-Nr.: "))
  (IF PKT
    (PROGN
      (COMMAND "_text" "po" "mz" PKT TEXTHHE "0" (ITOA POSNR))
      (SETQ POSNR (1+ POSNR))
      (COND
	((>= POSNR 1001) (SETQ DIGITS (* TEXTHHE 2.2)))
	((>= POSNR 101) (SETQ DIGITS (* TEXTHHE 1.7)))
	((>= POSNR 11) (SETQ DIGITS (* TEXTHHE 1.4)))
      )
      (COND
	((= TYP 0)
	 (PROGN
	   (COMMAND "_circle" PKT (+ (/ TEXTHHE 2) DIGITS))
	   (POS_NR_MACH)
	 )
	)
	((= TYP 1)
	 (PROGN
	   (SETQ R1 (POLAR PKT (BM 135) (+ (/ TEXTHHE 2) DIGITS))
		 R2 (POLAR PKT (BM 315) (+ (/ TEXTHHE 2) DIGITS))
	   )
	   (COMMAND "_rectang" R1 R2)
	   (POS_NR_MACH)
	 )
	)
	((= TYP 2)
	 (PROGN
	   (SETQ R1 (POLAR PKT (BM 225) (+ (/ TEXTHHE 2) DIGITS))
		 R2 (POLAR PKT (BM 315) (+ (/ TEXTHHE 2) DIGITS))
	   )
	   (COMMAND "_line" R1 R2 "")
	   (POS_NR_MACH)
	 )
	)
	((= TYP 3)
	 (PROGN
	   (SETQ R1 (POLAR PKT (BM 45) (+ (/ TEXTHHE 5) DIGITS))
	   )
	   (COMMAND "_polygon" "4" PKT "i" R1)
	   (POS_NR_MACH)
	 )
	)
	((= TYP 4)
	 (POS_NR_MACH)
	)
      )
    )
  )
  (SETVAR "osmode" A_OS)
)

(DEFUN VARREST ()
  (SETVAR "cecolor" aFARBE)
  (SETVAR "cmdecho" A_CMD)
  (SETVAR "clayer" A_LAY)
)


(DEFUN DIA_ZEIG	(/ V1 V2)
  (SETQ	V1 (DIMX_TILE "ctn")
	V2 (DIMY_TILE "ctn")
  ) ;_ Ende von SETQ
  (START_IMAGE "ctn")
  (FILL_IMAGE 0 0 V1 V2 -15)
  (SLIDE_IMAGE 0 0 V1 V2 "ctn")
  (END_IMAGE)
)

(DEFUN TAKE-LAYER ()
  (SETQ LAY-WAHL (NTH (ATOI $VALUE) LAY_LIS))
  (SETVAR "clayer" LAY-WAHL)
)

(DEFUN POS_LAY_EINL (/ LAYNAM EINTRAG)
  (SETQ	LAYNAM	(TBLNEXT "LAYER" T)
	EINTRAG	T
	LAY_LIS	(LIST "0")
  ) ;_ Ende von SETQ
  (WHILE EINTRAG
    (SETQ EINTRAG (TBLNEXT "LAYER"))
    (IF	EINTRAG
      (SETQ LAYNAM  (CDR (ASSOC 2 EINTRAG))
	    LAY_LIS (CONS LAYNAM LAY_LIS)
      ) ;_ Ende von SETQ
    )
  )
)


(DEFUN DDCOLORSTART (/ NFARBE)
  (IF (OR (= (GETVAR "cecolor") "BYLAYER")
	  (= (GETVAR "cecolor") "VONLAYER")
	  (= (GETVAR "cecolor") "256")
      )
    (SETQ NFARBE (ACAD_COLORDLG 255 1))
    (SETQ NFARBE (ACAD_COLORDLG (ATOI FARBE) 1))
  )
  (IF (= NFARBE 256)
    (SETVAR "cecolor" "256")
    (SETVAR "cecolor" (ITOA NFARBE))
  )
  (SETQ FARBE (ITOA NFARBE))
  (C:POSNR)
)


(DEFUN PRFE_FARBE ()
  (SETQ FARBE (ATOI $VALUE))
  (IF (OR (< FARBE 0) (> FARBE 256))
    (PRINC "\nFarbwert nicht zulssig")
    (PROGN (SETQ FARBE (ITOA FARBE)) (SETVAR "cecolor" FARBE) (FARBZEIG))
  )
)
(DEFUN FARBZEIG	(/ V1 V2)
  (SETQ	V1 (DIMX_TILE "color")
	V2 (DIMY_TILE "color")
  ) ;_ Ende von SETQ
  (START_IMAGE "color")
  (FILL_IMAGE 0 0 V1 V2 (ATOI (GETVAR "cecolor")))
  (END_IMAGE)
)

(DEFUN BM (GRAD / GRAD)
  (* PI (/ GRAD 180.0))
) ;_ Ende von defun

(PROMPT "\nPositionsnummern geladen.")
(PROMPT "\nStart mit -----> POSNR")
(PRINC)